SCWindow {
	classvar <>allWindows;
	
	var dataptr, <name, <>onClose, <view, <userCanClose=true;
	var <>alpha, <>bounds;
	
	*new { arg name = "panel", bounds, resizable = true, border = true;
		^super.new.initSCWindow(name, bounds, resizable, border)
	}
	initSCWindow { arg argName, argBounds, resizable, border;
		name = argName.asString;
		argBounds = argBounds ?? {Rect(128, 64, 400, 400)};
		allWindows = allWindows.add(this);
		view = SCTopView(nil, argBounds.moveTo(0,0));
		this.prInit(name, argBounds, resizable, border, view);
	}

	asView { ^view }
	add { arg aView; view.add(aView) }
	
	*closeAll {
		var list;
		list = allWindows.copy;
		allWindows = Array.new(8);
		list.do({ arg window; window.close; });
	}
		
	close {
	}
	closed {
		view.prClose;
		onClose.value; // call user function
		allWindows.remove(this);
	}
	isClosed { ^dataptr.isNil }

	fullScreen {
	}
	endFullScreen {
	}
	front {
	}
	refresh {
	}
	minimize {
	}
	setInnerExtent { arg w,h; // resize window keeping top left corner fixed
		var b;
		b = this.bounds;
		w = w ? b.width;
		if(h.isNil,{ h = b.height }, { h = h + 45 }); //+ 45 for window bar
		this.bounds = Rect(b.left,b.top + (b.height - h  ),w,h);
	}
	*screenBounds {
		       // MISSING
	}
	play {
		arg function;
		AppClock.play({ 
			if (dataptr.notNil, {
				function.value;
			});
		});
		
	}
	
	findByID { arg id;
		^view.findByID(id)
	}
			
	// PRIVATE
	// primitives
	prInit { arg argName, argBounds, resizable, border;
		bounds = argBounds;
		dataptr = true;
	}
	prClose {
		dataptr = nil;
	}	
	
	*viewPalette {
	}
}
