GtkCompactSpectrumDisplay : GtkSpectrumEnvelope {
	var freqs, <>m = 3;

	var freqGC, freqLayout;

	*new {
		arg n = 32;
		^super.new(n, mode: \horizontal).initGtkCompactSpectrumDisplay
	}
	initGtkCompactSpectrumDisplay {
		this.locked = true;
		this.style = \bar;
		freqLayout = PangoLayout(this.getPangoContext);
		drawCallQueue.add(\drawFrequencies, 300);
	}
	allocateResources {
		if (hasAllocatedResources || window.isNil, { ^this });
		freqGC = GdkGC.new(window);
		freqGC.setRgbFgColor("dark red");
		super.allocateResources
	}

	amps { ^this.values }
	amps_ { |values| this.values = values }
	freqs { ^freqs }
	freqs_ { |someFreqs| freqs = someFreqs; this.updateFrequencyLayout }

	spectrum_ { |spectrum| this.amps = spectrum.amps; this.freqs = spectrum.freqs; }

	drawFrequencies {
		var w, h;

		#w, h = freqLayout.getPixelSize;
		window.drawLayout(freqGC, width - w - 5, 5, freqLayout);
	}
	updateFrequencyLayout {
		var text;

		if (freqs.notNil, {
			text = "";

			freqs.do({
				arg freq, i;
				text = text ++ (i+1).asStringPad(2) ++ ": " ++ freq.asFloat.asStringPrecPad(5);
				if (((i + 1) % m) == 0, {
					text = text ++ "\n";
				}, {
					text = text ++ "\t";
				});
			});

			freqLayout.setMarkup("<small><tt>" ++ text ++ "</tt></small>");
		}, {
			freqLayout.setMarkup("");
		});
		this.invalidate;
	}

	finalize {
		this.unrefAll([
			freqGC, freqLayout
		]);
		super.finalize;
	}
}
