GtkFloatNumberBox : GtkSpinButton {
	var <>changedAction, muted, digits, step;
	*new {
		arg min = 0.0, max = 1.0, digits = 2, action, value = nil;
		^super.newFloatWithRange(0, 127, 10.pow(-1.0 * digits)).initGtkFloatNumberBox(min, max, digits, action, value);
	}
	initGtkFloatNumberBox {
		arg min, max, inDigits, action, value;
		digits = inDigits;
		step = 10.pow(-1.0 * digits);
		if (value.notNil, { this.setValue(value) });
		this.setRange(min, max);
		this.setEditable(false);
		this.setDigits(digits);
		changedAction = action;
		muted = false;
		this.setClickToEdit;
		this.connect('value-changed', { if (muted.not, { changedAction.value(this.value) }) });
	}

	set { arg v, m = true; muted = m; this.setValue(v); muted = false;  }
	value { ^this.getValue }
	value_ { |v| this.set(v, false); }
	bang { changedAction.value(this.getValue) }
	setRange {
		arg min, max;
		muted = true;
		if (min == max, {
			max = min + 1;
			this.setValue(min);
			this.setSensitive(false);
		}, {
			this.setSensitive(true);
		});
		super.setRange(min, max, step);
		muted = false
	}

	increment { this.spin('step-forward', 1) }
	decrement { this.spin('step-backward', 1) }
}
