GtkIntNumberBox : GtkSpinButton {
	var <>changedAction, muted;
	*new {
		arg min = 0, max = 127, action, value = nil;
		^super.newIntWithRange(0, 127).initGtkIntNumberBox(min, max, action, value);
	}
	initGtkIntNumberBox {
		arg min, max, action, value;
		if (value.notNil, { this.setValue(value) });
		this.setRange(min, max);
		this.setEditable(false);
		changedAction = action;
		muted = false;
		this.setClickToEdit;
		this.connect('value-changed', { if (muted.not, { changedAction.value(this.value) }) });
	}

	set { arg v, m = true; muted = m; this.setValue(v); muted = false;  }
	value { ^this.getValue.asInteger }
	value_ { |v| this.set(v, false); }
	bang { changedAction.value(this.getValue.asInteger) }
	setRange {
		arg min, max;
		muted = true;
		if (min == max, {
			max = min + 1;
			this.setValue(min);
			this.setSensitive(false);
		}, {
			this.setSensitive(true);
		});
		super.setRange(min, max, 1);
		muted = false
	}

	increment { this.spin('step-forward', 1) }
	decrement { this.spin('step-backward', 1) }
}
