GtkPlusButtonArray : GtkVBox {
	var <nx, <ny, <w, <h, current, <value, action, <marked;
	var table, buttons, <activeSize = 0;

	*new {
		arg action, nx = 16, ny = 2, w = 32, h = 32, marked = false;
		^super.new.initGtkPlusButtonArray(action, nx, ny, w, h, marked)
	}
	initGtkPlusButtonArray {
		arg inAction, inNx, inNy, inW, inH, inMarked;

		action = inAction;
		nx = inNx;
		ny = inNy;
		w = inW;
		h = inH;
		marked = inMarked;

		table = GtkTable(w, h);
		buttons = Array.fill(ny, {
			arg j;
			Array.fill(nx, {
				arg i;		var button;
				button = GtkButton.new.setSizeRequest(w, h);
				button.add(GtkEventBox.new.show);
				button.setProperty('can-focus', false);
				button.getChild.modifyBg('normal', GdkColor.newFromNorm(0.0, 0.0, 0.0));
				button.getChild.modifyBg('prelight', GdkColor.newFromNorm(0.5, 0.5, 0.5));
				button.getChild.modifyBg('active', GdkColor.newFromNorm(0.5, 0.5, 0.5));
				button.setSensitive(false);
				button.connect('clicked', {
					this.value = i + (j * ny);
				});
				table.attach(button, i, i + 1, j, j + 1);
				button
			});
		});

		table.showChildren;

		this.packStart(table, true, true);
		this.showChildren
	}

	size { ^(nx*ny) }
	activeSize_ {
		arg n;			var x, y;
		n = min(n, this.size);
		this.size.do({
			arg i;

			x = i % nx;
			y = (i / nx).asInteger;

			if (i < n, {
				buttons[y][x].setSensitive(true)
			}, {
				buttons[y][x].setSensitive(false)
			});
		});
		activeSize = n;
	}
	extend { this.activeSize = activeSize + 1 }
	value_ { arg n; this.set(n); action.value(n); }
	set {
		arg n;			var x, y, button;

		if (n < 0 or: { n > activeSize }, { ^this });

		x = n % nx;
		y = (n / nx).asInteger;

		button = buttons[y][x];

		if (marked, {
			if (current.notNil, {
				current.getChild.modifyBg('normal', GdkColor.newFromNorm(0.0, 0.0, 0.0));
			});
			button.getChild.modifyBg('normal', GdkColor.newFromNorm(1.0, 0.0, 0.0));
		});

		current = button;

		value = n;
	}

	marked_ {
		var value;
		if (value != marked, {
			if (value, {
				if (current.notNil, {
					current.getChild.modifyBg('normal', GdkColor.newFromNorm(1.0, 0.0, 0.0));
				});
			}, {
				if (current.notNil, {
					current.getChild.modifyBg('normal', GdkColor.newFromNorm(0.0, 0.0, 0.0));
				});
			});
			marked = value;
		});
	}
}
