GtkPlusShortArrayDisplay : GtkHBox {
	var <labels, <>precision = 2, small = true;
	*new {
		arg n = 8;
		^super.new.initGtkPlusShortArrayDisplay(n)
	}
	initGtkPlusShortArrayDisplay {
		arg n;		var box;
		box = this.prMakeBox;
		labels = Array.fill(n, { GtkLabel.new("-") });
		labels.do({ |label| box.packStart(label, this.prExpandFill, this.prExpandFill) });
		box.showChildren;
		box.show;
		this.packStart(box)
	}
	update {
		arg array;	var text;
		labels.do({
			arg label, i;
			text = "<tt>" ++ array[i].asFloat.asStringPrecPad(precision) ++ "</tt>";
			if (small, {
				text = "<small>" ++ text ++ "</small>";
			});
			label.setMarkup(text);
		});
	}

	prMakeBox { ^GtkHBox.new; }
	prExpandFill { ^true }
}
