GtkSpectrumView : GtkVBox {
	var freqs, amps;
	*new {
		arg n;
		^super.new.initGtkSpectrumView(n)
	}
	initGtkSpectrumView {
		arg n;		var hbox, nbox;

		amps = GtkSpectrumEnvelope(n);
		freqs = Array.fill(n, { arg i; GtkFloatNumberBox(0.0, 100.0, 2) });

		hbox = GtkHBox.new;
		hbox.packStart(amps, true, true);
		hbox.packStart(freqs.asGtkVBox, false, false);
		hbox.showChildren;

		this.packStart(hbox, false, false);

		this.showChildren;
	}

	n { ^amps.n }
	freq { arg i; ^freqs[i].value }
	amp { arg i; ^amps.values[i] }

	freqs { ^(freqs.collect({ |f| f.value })) }
	freqs_ { |values| values.do({ |value, i| freqs[i].value = value }) }
	amps { ^amps.values }
	amps_ { |values| amps.values = values }

	swap {
		arg other;		var freqs0, amps0;

 		freqs0 = this.freqs;
 		amps0 = this.amps;

		this.freqs = other.freqs;
		this.amps = other.amps;

		other.freqs = freqs0;
		other.amps = amps0;
	}

	freqArgArray {
		arg baseindex;
		var array;
		array = Array.new(freqs.n * 2);
		freqs.n.do({
			arg i;
			array[i * 2] = baseindex + i;
			array[(i * 2) + 1] = this.freq(i);
		})
		^array
	}
	ampArgArray {
		arg baseindex;
		var array;
		array = Array.new(freqs.n * 2);
		freqs.n.do({
			arg i;
			array[i * 2] = baseindex + i;
			array[(i * 2) + 1] = this.amp(i);
		})
		^array
	}
}
