GladeXML : GObject {
	var autoconnectTableInUse;

	*new {
		arg...args;
		^super.new.performList(\initWithNewObject, args)
	}
	initWithNewObject {
		arg filename, root, namespace;
		this.newGladeXML_request(filename, root, namespace);
		this.wrap(Async.wait);
	}
	newGladeXML_request {
		arg filename, root, namespace;
		_prGladeXmlNew;
		^this.primitiveFailed
	}

	getWidget {
		arg name;
		this.getWidget_request(name);
		^GObject.wrap(Async.wait);
	}
	getWidget_request {
		arg name;
		_prGladeXmlGetWidget;
		^this.primitiveFailed
	}

	signalAutoconnect {
		arg table;
		if (autoconnectTableInUse.isNil, {
			autoconnectTableInUse = table;
			this.signalAutoconnect_request;
			Async.wait;
			autoconnectTableInUse = nil;
		}, {
			"An autoconnection request is already being performed for this object".postln;
			this.verboseHalt;
		});
	}
	signalAutoconnect_request {
		_prGladeXmlSignalAutoconnect;
		^this.primitiveFailed
	}

	prPerformAutoconnect {
		arg ptr, signal, handler, after;
		var function, wrapper;
		
		function = autoconnectTableInUse.at(handler);
		if (function.isNil, {
			Post << thisMethod.asString << ": " << "No handler named " << handler << nl;
			Post << "Autoconnection skipped" << nl;
			^this
		});

		wrapper = GObject.wrap(ptr);		
		if (wrapper.isNil, {
			Post << thisMethod.asString << ": " << "Could not wrap GObject at " << ptr << nl;
			Post << "Autoconnection skipped" << nl;
			^this
		});

		if (after, {
			wrapper.connectAfter(signal, function);
		}, {
			wrapper.connect(signal, function);
		});

		AsyncRequestQueue.sendVoidTrigger
	}
}
