Gtk {
	classvar <timeoutCallbacks, timeoutCallbackId;
	classvar <callbackResults;

	*initClass {
		timeoutCallbacks = Dictionary.new;
		timeoutCallbackId = Routine({ var i = 0; loop({ i = i + 1; i.yield;})});
	}

	*timeoutAdd {
		arg interval, function ... args;
		var id1, id2;

		id1 = timeoutCallbackId.next;

		//Post	<< "Connecting timeout with id1 " << id1 << "\n";

		this.timeoutAdd_request(interval, id1);
		id2 = Async.wait;
		timeoutCallbacks.put(id1, [id2, interval, function, args]);

		^id1
	}
	*timeoutAdd_request {
		arg interval, id1;
		_prGtkTimeoutAdd;
		^this.primitiveFailed
	}

	*timeoutRemove {
		arg id1;
		var id2, interval, function, extraArgs;

		if (id1.notNil, {
			#id2, interval, function, extraArgs = timeoutCallbacks.at(id1);
			if (id2.notNil, {
				this.timeoutRemove_request(id2);
				Async.wait;
				timeoutCallbacks.removeAt(id1);
			})
		});
	}
	*timeoutRemove_request {
		arg interval, id1;
		_prGtkTimeoutRemove;
		^this.primitiveFailed
	}

	*prTimeoutHandler {
		arg id1;
		var id2, interval, function, args;
		var result, newinterval;

		//"TIMEOUT HANDLER".postln;
		#id2, interval, function, args = timeoutCallbacks.at(id1);

		Async.run({
			//"STARTING CALLBACK".postln;
			result = function.valueArray([interval] ++ args);
			if (result.isKindOf(Boolean), {
				if (result.not,  {
					timeoutCallbacks.removeAt(id1);
				});

				result
			}, {
				newinterval = result.asInteger;
				if (newinterval != interval, {
					this.timeoutAdd_request(newinterval, id1);
					id2 = Async.wait;
					timeoutCallbacks.put(id1, [id2, newinterval, function, args]);

					false
				}, {
					true
				});
			});
			//"CALLBACK TERMINATED".postln;
		}, [], {
			arg value;
			//Post << "STORING CALLBACK RESULT: " << value << "\n";
			callbackResults = callbackResults.add(value);
			//Post << "CALLBACK RESULT STACK IS NOW: " << callbackResults.size << "\n";
			GtkServer.sendResultTrigger;
		}, {
			GtkServer.sendAbortTrigger;
		}, mode: 'callback');
	}

	*mainQuit {
		_prGtkMainQuit;
		^this.primitiveFailed		
	}
}
