GtkButton : GtkBin {
	*new {
		arg...args;
		^super.new.performList(\initWithNewObject, args)
	}
	initWithNewObject {
		this.newGtkButton_request;
		this.wrap(Async.wait)
	}
	newGtkButton_request {
		_prGtkButtonNew;
		^this.primitiveFailed
	}

	*newWithLabel {
		arg...args;
		^super.new.performList(\initWithNewObjectWithLabel, args)
	}
	initWithNewObjectWithLabel {
		arg text = "Missing text";
		this.newGtkButtonWithLabel_request(text);
		this.wrap(Async.wait)	
	}
	newGtkButtonWithLabel_request {
		arg text = "Missing text";
		_prGtkButtonNewWithLabel;
		^this.primitiveFailed
	}

	*newFromStock {
		arg...args;
		^super.new.performList(\initWithNewObjectFromStock, args)
	}
	initWithNewObjectFromStock {
		arg name;
		this.newGtkButtonNewFromStock_request(name);
		^super.new.wrap(Async.wait)
	}
	newGtkButtonNewFromStock_request {
		arg name;
		_prGtkButtonNewFromStock;
		^this.primitiveFailed
	}

	setLabel {
		arg text;
		this.setLabel_request(text);
		^Async.wait
	}
	setLabel_request {
		arg text;
		_prGtkButtonSetLabel;
		^this.primitiveFailed
	}

	getLabel {
		this.getLabel_request;
		^Async.wait
	}
	getLabel_request {
		_prGtkButtonGetLabel;
		^this.primitiveFailed
	}

	// EXTRA
	*newWithStockImage {
		arg name, size = 'button', callback;
		var newButton, image;
		newButton = GtkButton.new;
		image = GtkImage.newFromStock(name, size);
		newButton.add(image);
		image.show;
		if (callback.notNil, { newButton.connect('clicked', callback) });
		^newButton
	}
	*newWithImage {
		arg filename;
		var newButton, image;

		newButton = GtkButton.new;
		image = GtkImage.newFromFile(filename);
		newButton.add(image);
		image.show;

		^newButton;
	}
	
	connectPopupMenu {
		arg function, button;
		
		this.connect("button-press-event", {
			arg widget, event;
			if (event.notNil, {
				if (button.isNil || (event.button == button), {
					function.value(event.button, event.time);
					true;
				}, {
					false;
				});
			});
		});
	}

	*newWithMultipleStates {
		arg inStates, function, initEmission = false;
		var button, states, state, function2;
		
		function2 = {
			if (states.at(0).isKindOf(Association), {
				button.setLabel(states.at(state).key.asString);
				function.value(states.at(state).value, state);
			}, {
				button.setLabel(states.at(state).asString);
				function.value(states.at(state), state);
			});
		};

		if (inStates.size == 0, {
			^nil
		});

		if (inStates.isKindOf(Dictionary), {
			states = [];
			inStates.keysValuesDo({ arg key, value; states = states.add(key -> value); });
		}, {
			states = inStates.copy;
		});

		state = 0;
		if (states.at(0).isKindOf(Association), {
			button = GtkButton.newWithLabel(states.at(0).key.asString);
		}, {
			button = GtkButton.newWithLabel(states.at(0).asString);
		});
		button.connect('clicked', 		{
			state = (state + 1) % states.size;
			function2.value;
		});

		if (initEmission, { function2.value });

		^button
	}

	*newWithLabelAndCallback {
		arg text, function;
		var button;
		button = this.newWithLabel(text);
		button.connect('clicked', function);
		^button
	}

	defaultSizeAsToplevel {	^#[320, 200] }
}
