GtkContainer : GtkWidget {
	add {
		arg child;
		this.add_request(child);
		Async.wait
	}
	add_request {
		arg child;
		_prGtkContainerAdd;
		^this.primitiveFailed
	}

	remove {
		arg child;
		this.remove_request(child);
		Async.wait
	}
	remove_request {
		arg child;
		_prGtkContainerRemove;
		^this.primitiveFailed
	}

	setBorderWidth {
		arg n;
		this.setBorderWidth_request(n);
		Async.wait
	}
	setBorderWidth_request {
		arg n;
		_prGtkContainerSetBorderWidth;
		^this.primitiveFailed
	}

	children {
		var ptrArray, wrappers;
		var wrapper;

		this.children_request;
		ptrArray = Async.wait;

		wrappers = Array.new;
		ptrArray.do({
			arg ptr;
			if (ptr.notNil, {
				wrapper = GObject.wrap(ptr);
				if (wrapper.notNil, {
					wrappers = wrappers.add(wrapper)
				});
			});
		});

		^wrappers
	}
	children_request {
		_prGtkContainerChildren;
		^this.primitiveFailed
	}

	// EXTRA
	showAllChildren { this.showChildren(true) }
	showChildren {
		arg recursively = false;

		this.children.do({
			arg widget;

			if (widget.isKindOf(GtkWidget), {
				widget.show;
			});

			if (recursively.isKindOf(Boolean), {
				if (widget.isKindOf(GtkContainer) && recursively, {   
					widget.showAllChildren(recursively);
				});
			}, {
				if (widget.isKindOf(GtkContainer) && (recursively > 0), {   
					widget.showAllChildren(recursively - 1);
				});
			});
		});
	}

	removeAll {
		this.children.do({
			arg child;
			this.remove(child);
		});
	}

	showAll {
		arg widgets;
		if (widgets.isNil, {
			^super.showAll
		}, {
			widgets.do({
				arg widget;
				widget.show;
			});
		});
	}

	nChildren {
		this.nChildren_request;
		^Async.wait
	}
	nChildren_request {
		_prGtkContainerNChildren;
		^this.primitiveFailed
	}
}
