GtkFileSelection : GtkDialog {
	initWithNewObject {
		arg title;
		this.newGtkFileSelection_request(title);
		this.wrap(Async.wait);
	}
	newGtkFileSelection_request {
		arg title;
		_prGtkFileSelectionNew;
		^this.primitiveFailed
	}

	setFilename {
		arg filename;
		this.setFilename_request(filename);
		Async.wait
	}
	setFilename_request {
		arg filename;
		_prGtkFileSelectionSetFilename;
		^this.primitiveFailed
	}

	getFilename {
		this.getFilename_request;
		^Async.wait
	}
	getFilename_request {
		_prGtkFileSelectionGetFilename;
		^this.primitiveFailed
	}

	showFileopButtons {
		this.showFileopButtons_request;
		Async.wait
	}
	showFileopButtons_request {
		_prGtkFileSelectionShowFileopButtons;
		^this.primitiveFailed
	}

	hideFileopButtons {
		this.hideFileopButtons_request;
		Async.wait
	}
	hideFileopButtons_request {
		_prGtkFileSelectionHideFileopButtons;
		^this.primitiveFailed
	}

	getSelections {
		this.getSelections_request;
		^Async.wait
	}
	getSelections_request {
		_prGtkFileSelectionGetSelections;
		^this.primitiveFailed
	}

	setSelectMultiple {
		arg value;
		this.setSelectMultiple_request(value);
		Async.wait
	}
	setSelectMultiple_request {
		arg value;
		_prGtkFileSelectionSetSelectMultiple;
		^this.primitiveFailed
	}

	getSelectMultiple {
		this.getSelectMultiple_request;
		^Async.wait
	}
	getSelectMultiple_request {
		_prGtkFileSelectionGetSelectMultiple;
		^this.primitiveFailed
	}

	complete {
		arg pattern;
		this.complete_request(pattern);
		Async.wait
	}
	complete_request {
		arg pattern;
		_prGtkFileSelectionComplete;
		^this.primitiveFailed
	}

	// subwidget access
	dirList {
		^GObject.wrap(this.prDirList)
	}
	prDirList {
		_prGtkFileSelectionDirList;
		^this.primitiveFailed
	}

	fileList {
		^GObject.wrap(this.prFileList)
	}
	prFileList {
		_prGtkFileSelectionFileList;
		^this.primitiveFailed
	}

	selectionEntry {
		^GObject.wrap(this.prSelectionEntry)
	}
	prSelectionEntry {
		_prGtkFileSelectionSelectionEntry;
		^this.primitiveFailed
	}

	selectionText {
		^GObject.wrap(this.prSelectionText)
	}
	prSelectionText {
		_prGtkFileSelectionSelectionText;
		^this.primitiveFailed
	}

	mainVBox {
		^GObject.wrap(this.prMainVBox)
	}
	prMainVBox {
		_prGtkFileSelectionMainVBox;
		^this.primitiveFailed
	}

	okButton {
		^GObject.wrap(this.prOkButton)
	}
	prOkButton {
		_prGtkFileSelectionOkButton;
		^this.primitiveFailed
	}

	cancelButton {
		^GObject.wrap(this.prCancelButton)
	}
	prCancelButton {
		_prGtkFileSelectionCancelButton;
		^this.primitiveFailed
	}

	helpButton {
		^GObject.wrap(this.prHelpButton)
	}
	prHelpButton {
		_prGtkFileSelectionCancelButton;
		^this.primitiveFailed
	}

	// Extra
	*askAndDo {
		arg title, function, multiple = false, filename;
		var dialog;

		dialog = GtkFileSelection.new(title);
		dialog.okButton.connect("clicked", {
			filename = dialog.getFilename;
			dialog.destroy;
			if (filename.last != $/,  {
				function.value(filename);
			});
		});
		dialog.cancelButton.connect("clicked", {
			dialog.destroy
		});
		if (filename.notNil, {
			dialog.setFilename(filename);
		});
		dialog.show;
		^dialog
	}
}
