GtkNotebook : GtkContainer {
	*new {
		this.newGtkNotebook_request;
		^super.new.wrap(Async.wait)
	}
	*newGtkNotebook_request {
		_prGtkNotebookNew;
		^this.primitiveFailed	
	}

	appendPage {
		arg child, label;
		this.appendPage_request(child, label);
		Async.wait
	}
	appendPage_request {
		arg child, label;
		_prGtkNotebookAppendPage;
		^this.primitiveFailed
	}

	prependPage {
		arg child, label;
		this.prependPage_request(child, label);
		Async.wait
	}
	prependPage_request {
		arg child, label;
		_prGtkNotebookPrependPage;
		^this.primitiveFailed
	}

	insertPage {
		arg child, label, position;
		this.insertPage_request(child, label, position);
		Async.wait
	}
	insertPage_request {
		arg child, label, position;
		_prGtkNotebookInsertPage;
		^this.primitiveFailed
	}

	removePage {
		arg n;
		this.removePage_request(n);
		Async.wait
	}
	removePage_request {
		arg n;
		_prGtkNotebookRemovePage;
		^this.primitiveFailed
	}

	getCurrentPage {
		this.getCurrentPage_request;
		^Async.wait
	}
	getCurrentPage_request {
		_prGtkNotebookGetCurrentPage;
		^this.primitiveFailed
	}

	getNthPage {
		this.getNthPage_request;
		^GObject.wrap(Async.wait)
	}
	getNthPage_request {
		arg n;
		_prGtkNotebookGetNthPage;
		^this.primitiveFailed
	}

	getNPages {
		this.getNPages_request;
		^Async.wait
	}
	getNPages_request {
		_prGtkNotebookGetNPages;
		^this.primitiveFailed
	}

	getPageNum {
		arg child;
		this.getPageNum_request(child);
		^Async.wait
	}
	getPageNum_request {
		arg child;
		_prGtkNotebookGetPageNum;
		^this.primitiveFailed
	}

	setCurrentPage {
		arg n;
		this.setCurrentPage_request(n);
		Async.wait
	}
	setCurrentPage_request {
		arg n;
		_prGtkNotebookSetCurrentPage;
		^this.primitiveFailed
	}

	nextPage {
		this.nextPage_request;
		Async.wait
	}
	nextPage_request {
		_prGtkNotebookNextPage;
		^this.primitiveFailed
	}

	prevPage {
		this.prevPage_request;
		Async.wait
	}
	prevPage_request {
		_prGtkNotebookPrevPage;
		^this.primitiveFailed
	}

	setScrollable {
		arg value;
		this.setScrollable_request(value);
		Async.wait
	}
	setScrollable_request {
		arg value = true;
		_prGtkNotebookSetScrollable;
		^this.primitiveFailed
	}

	getScrollable {
		arg value;
		this.getScrollable_request;
		^Async.wait
	}
	getScrollable_request {
		_prGtkNotebookGetScrollable;
		^this.primitiveFailed
	}

	popupDisable {
		this.popupDisable_request;
		Async.wait
	}
	popupDisable_request {
		_prGtkNotebookPopupDisable;
		^this.primitiveFailed
	}

	popupEnable {
		this.popupEnable_request;
		Async.wait
	}
	popupEnable_request {
		_prGtkNotebookPopupEnable;
		^this.primitiveFailed
	}


	// EXTRA
	appendPageWithText {
		arg child, text;
		var label;
		label = GtkLabel.new(text);
		^this.appendPage(child, label)
	}
	prependPageWithText {
		arg child, text;
		var label;
		label = GtkLabel.new(text);
		^this.prependPage(child, label)
	}
	insertPageWithText {
		arg child, text, position;
		var label;
		label = GtkLabel.new(text);
		^this.insertPage(child, label, position)
	}
}
