GtkRadioButton : GtkCheckButton {
	initWithNewObject {
		arg group;
		this.newGtkRadioButton_request(if (group.notNil, { group.ptr }, { nil }));
		this.wrap(Async.wait)
	}
	newGtkRadioButton_request {
		arg group;
		_prGtkRadioButtonNew;
		^this.primitiveFailed
	}

	initWithNewObjectWithLabel {
		arg group, text = "Missing text";
		if (group.notNil, { [group, group.ptr.asString] }, { [nil] }).postln;
		this.newGtkRadioButtonWithLabel_request(if (group.notNil, { group.ptr }, { nil }), text);
		this.wrap(Async.wait)	
	}
	newGtkRadioButtonWithLabel_request {
		arg group, text = "Missing text";
		_prGtkRadioButtonNewWithLabel;
		^this.primitiveFailed
	}

	*newFromWidget {
		arg...args;
		^this.newEmpty.performList(\initWithNewObjectFromWidget, args)
	}
	initWithNewObjectFromWidget {
		arg widget;
		this.newGtkRadioButtonFromWidget_request;
		this.wrap(Async.wait)
	}
	newGtkRadioButtonFromWidget_request {
		arg widget;
		_prGtkRadioButtonNewFromWidget;
		^this.primitiveFailed
	}

	*newWithLabelFromWidget {
		arg...args;
		^super.newEmpty.performList(\initWithNewObjectWithLabelFromWidget, args)
	}
	initWithNewObjectWithLabelFromWidget {
		arg widget, text;
		this.newGtkRadioButtonWithLabelFromWidget_request(widget, text);
		this.wrap(Async.wait)	
	}
	newGtkRadioButtonWithLabelFromWidget_request {
		arg widget, text;
		_prGtkRadioButtonNewWithLabelFromWidget;
		^this.primitiveFailed
	}

	setGroup {
		arg group;
		this.setGroup_request(if (group.notNil, { group.ptr }, { nil }));
		Async.wait
	}
	setGroup_request {
		arg group;
		_prGtkRadioButtonSetGroup;
		^this.primitiveFailed
	}

	getGroup {
		this.getGroup_request;
		^GtkRadioGroup.wrap(Async.wait)
	}
	getGroup_request {
		_prGtkRadioButtonGetGroup;
		^this.primitiveFailed
	}

	*newGroup {
		arg labels, function, n = 0;		var group, button, buttons;
		
		n = n.clip(0, labels.size - 1);

		buttons = Array.fill(labels.size, {
			arg i;
			button = this.newWithLabel(group, labels[i]);
			button.setActive(n == i);
			button.connect('clicked', { function.value(i) });
			group = group ?? { button.getGroup };
			button
		});
		^buttons
	}
}
