GtkTable : GtkContainer {
	*new {
		arg n = 1, m = 1, homogeneous = false;
		this.newGtkTable_request(n, m, homogeneous);
		^super.new.wrap(Async.wait)
	}
	*newGtkTable_request {
		arg n = 1, m = 1, homogeneous = false;
		_prGtkTableNew;
		^this.primitiveFailed	
	}

	resize {
		arg n = 1, m = 1;
		this.resize_request(n, m);
		Async.wait
	}
	resize_request {
		arg n = 1, m = 1;
		_prGtkTableResize;
		^this.primitiveFailed
	}

	attach {
		arg child, left, right, top, bottom, xoptions = 0, yoptions = 0, xpadding = 0, ypadding = 0;
		this.attach_request(child, left, right, top, bottom, xoptions, yoptions, xpadding, ypadding);
		Async.wait
	}
	attach_request {
		arg child, left, right, top, bottom, xoptions = 0, yoptions = 0, xpadding = 0, ypadding = 0;
		_prGtkTableAttach;
		^this.primitiveFailed
	}

	setRowSpacings {
		arg n = 0;
		this.setRowSpacings_request(n);
		Async.wait
	}
	setRowSpacings_request {
		arg n = 0;
		_prGtkTableSetRowSpacings;
		^this.primitiveFailed
	}

	setColSpacings {
		arg n = 0;
		this.setColSpacings_request(n);
		Async.wait
	}
	setColSpacings_request {
		arg n = 0;
		_prGtkTableSetColSpacings;
		^this.primitiveFailed
	}


	// Extra
	packMany {
		arg rows, xa, ya;
		
		this.resize(rows.size, rows.collect({ |i| i.size }).maxItem);
		
		rows.do({
			arg row, j;
			row.do({
				arg widget, i;
				this.attach(widget, i, i + 1, j, j + 1, xa[i], ya[i]);
				widget.show;
			});
		});
	}

	packArrays {
		arg ...args;		var ncols, nrows, widget, params;

		ncols = (args.size / 2).asInteger;
		nrows = Array.fill(ncols, { |i| args[i*2].size }).maxItem;
		
		this.resize(nrows, ncols);
		
		nrows.do({
			arg j;
			ncols.do({
				arg i;
				widget = args[i*2][j];
				params = args[i*2 + 1] ? [];
				this.attach(widget, i, i + 1, j, j + 1,
							params[0] ? 0, params[1] ? 0, params[2] ? 0, params[3] ? 0);
				widget.show;
			});
		});
	}
}
