GtkTextBuffer : GObject {
	*new {
		arg ...args;
		^super.new.performList(\initWithNewObject, args)
	}
	initWithNewObject {
		this.newGtkTextBuffer_request;
		^this.wrap(Async.wait)
	}
	newGtkTextBuffer_request {
		_prGtkTextBufferNew;
		^this.primitiveFailed
	}

	setText {
		arg text;
		var segment, index;

		if (text.size <= 10000, {
			this.setText_request(text);
			Async.wait
		}, {
			this.setText(text.copyFromStart(9999));
			index = 10000;
			while({ index < text.size }, {
				this.append(text.copyRange(index, index + 9999));
				index = index + 10000;
			});
		});
	}
	setText_request {
		arg text;
		_prGtkTextBufferSetText;
		^this.primitiveFailed
	}

	getText {
		arg beginIter, endIter, hidden = false;
		this.getText_request(beginIter, endIter, hidden);
		^Async.wait
	}
	getText_request {
		arg beginIter, endIter, hidden = false;
		_prGtkTextBufferGetText;
		^this.primitiveFailed
	}

	getIterAtMark {
		arg mark;
		this.getIterAtMark_request(mark);
		^Async.wait
	}
	getIterAtMark_request {
		arg mark;
		_prGtkTextBufferGetIterAtMark;
		^this.primitiveFailed
	}

	getIterAtLineOffset {
		arg line, offset;
		this.getIterAtLineOffset_request(line, offset);
		^Async.wait
	}
	getIterAtLineOffset_request {
		arg line, offset;
		_prGtkTextBufferGetIterAtLineOffset;
		^this.primitiveFailed
	}

	getIterAtLineIndex {
		arg line, index;
		this.getIterAtLineIndex_request(line, index);
		^Async.wait
	}
	getIterAtLineIndex_request {
		arg line, index;
		_prGtkTextBufferGetIterAtLineIndex;
		^this.primitiveFailed
	}

	getIterAtLine {
		arg line;
		this.getIterAtLine_request(line);
		^Async.wait
	}
	getIterAtLine_request {
		arg line;
		_prGtkTextBufferGetIterAtLine;
		^this.primitiveFailed
	}

	getIterAtOffset {
		arg offset;
		this.getIterAtOffset_request(offset);
		^Async.wait
	}
	getIterAtOffset_request {
		arg offset;
		_prGtkTextBufferGetIterAtOffset;
		^this.primitiveFailed
	}

	getStartIter {
		this.getStartIter_request;
		^Async.wait
	}
	getStartIter_request {
		_prGtkTextBufferGetStartIter;
		^this.primitiveFailed
	}

	getEndIter {
		this.getEndIter_request;
		^Async.wait
	}
	getEndIter_request {
		_prGtkTextBufferGetEndIter;
		^this.primitiveFailed
	}

	getBounds {
		this.getBounds_request;
		^Async.wait
	}
	getBounds_request {
		_prGtkTextBufferGetBounds;
		^this.primitiveFailed
	}

	insert {
		arg iter, text;
		this.insert_request(iter, text);
		Async.wait
	}
	insert_request {
		arg iter, text;
		_prGtkTextBufferInsert;
		^this.primitiveFailed
	}

	insertWithTag {
		arg iter, text, tag;
		this.insertWithTag_request(iter, text, tag);
		^Async.wait
	}
	insertWithTag_request {
		arg iter, text, tag;
		_prGtkTextBufferInsertWithTag;
		^this.primitiveFailed
	}

	getMark {
		arg name;
		this.getMark_request(name)
		^GObject.wrap(Async.wait)
	}
	getMark_request {
		arg name;
		_prGtkTextBufferGetMark;
		^this.primitiveFailed
	}
	getInsert {
		this.getInsert_request;
		^GObject.wrap(Async.wait)
	}
	getInsert_request {
		_prGtkTextBufferGetInsert;
		^this.primitiveFailed
	}
	getSelectionBound {
		this.getSelectionBound_request;
		^GObject.wrap(Async.wait)
	}
	getSelectionBound_request {
		_prGtkTextBufferGetSelectionBound;
		^this.primitiveFailed
	}
	getSelectionBounds {
		this.getSelectionBounds_request;
		^Async.wait
	}
	getSelectionBounds_request {
		_prGtkTextBufferGetSelectionBounds;
		^this.primitiveFailed
	}

	createMark {
		arg name, iter, leftGravity = true;
		this.createMark_request(name, iter, leftGravity)
		^GObject.wrap(Async.wait)
	}
	createMark_request {
		arg name, iter, leftGravity;
		_prGtkTextBufferCreateMark;
		^this.primitiveFailed
	}

	deleteMark {
		this.deleteMark_request;
		Async.wait
	}
	deleteMark_request {
		arg mark;
		_prGtkTextBufferDeleteMark;
		^this.primitiveFailed
	}


	// EXTRA
	append {
		arg text;
		var iter;
		iter = this.getEndIter;
		this.insert(iter, text);
	}
	appendWithTag {
		arg text, tag;
		var iter;
		iter = this.getEndIter;
		this.insertWithTag(iter, text, tag);
	}

	getSelectedText {
		^this.getText(this.getIterAtMark(this.getInsert), this.getIterAtMark(this.getSelectionBound))
	}
}
