GtkTextView : GtkContainer {
	var endMark;

	*new {
		this.newGtkTextView_request;
		^super.new.wrap(Async.wait)
	}
	*newGtkTextView_request {
		_prGtkTextViewNew;
		^this.primitiveFailed;
	}	

	*newWithBuffer {
		arg buffer;
		^super.new.initWithBuffer(buffer)
	}
	initWithBuffer {
		arg buffer;
		this.newGtkTextViewWithBuffer_request(buffer);
		this.wrap(Async.wait)
	}
	newGtkTextViewWithBuffer_request {
		arg buffer;
		_prGtkTextViewNewWithBuffer;
		^this.primitiveFailed;
	}

	getBuffer {
		this.getBuffer_request;
		^GObject.wrap(Async.wait)
	}
	getBuffer_request {
		_prGtkTextViewGetBuffer;
		^this.primitiveFailed;
	}

	setBuffer {
		arg buffer;
		this.setBuffer_request(buffer);
		Async.wait
	}
	setBuffer_request {
		arg buffer;
		_prGtkTextViewSetBuffer;
		^this.primitiveFailed;
	}

	scrollToMark {
		arg mark, within_margin, xalign, yalign;
		if (xalign.notNil && yalign.notNil, {
			this.scrollToMark_request(mark, within_margin, true, xalign,yalign);
		}, {
			this.scrollToMark_request(mark, within_margin, nil, nil, nil);
		});
		Async.wait
	}
	scrollToMark_request {
		arg mark, within_margin, use_align, xalign, yalign;
		_prGtkTextViewScrollToMark;
		^this.primitiveFailed
	}

	scrollToIter {
		arg iter, within_margin, xalign, yalign;
		if (xalign.notNil && yalign.notNil, {
			this.scrollToIter_request(iter, within_margin, true, xalign,yalign);
		}, {
			this.scrollToIter_request(iter, within_margin, nil, nil, nil);
		});
		Async.wait
	}
	scrollToIter_request {
		arg iter, within_margin, use_align, xalign, yalign;
		_prGtkTextViewScrollToIter;
		^this.primitiveFailed
	}

	setEditable {
		arg value = true;
		this.setEditable_request(value);
		Async.wait
	}
	setEditable_request {
		arg value = true;
		_prGtkTextViewSetEditable;
		^this.primitiveFailed;
	}

	getEditable {
		^Async.wait(this.getEditable_request)
	}
	getEditable_request {
		_prGtkTextViewGetEditable;
		^this.primitiveFailed;
	}

	// EXTRA
	scrollAtEnd {
		this.scrollToEnd
	}
	scrollToEnd {
		var buffer;

		if (endMark.isNil, {
			buffer = this.getBuffer;
			endMark = buffer.createMark(nil, buffer.getEndIter, false);
		});

		this.scrollToMark(endMark, 0.0, 1.0, 0.0);
	}
}
