GtkToggleButton : GtkButton {
	initWithNewObject {
		this.newGtkToggleButton_request;
		this.wrap(Async.wait)
	}
	newGtkToggleButton_request {
		_prGtkToggleButtonNew;
		^this.primitiveFailed
	}

	initWithNewObjectWithLabel {
		arg text = "Missing text";
		this.newGtkToggleButtonWithLabel_request(text);
		this.wrap(Async.wait)	
	}
	newGtkToggleButtonWithLabel_request {
		arg text = "Missing text";
		_prGtkToggleButtonNewWithLabel;
		^this.primitiveFailed
	}

	setMode {
		arg value = true;
		this.setMode_request(value);
		Async.wait
	}
	setMode_request {
		arg value;
		_prGtkToggleButtonSetMode;
		^this.primitiveFailed
	}

	getMode {
		this.getMode_request;
		^Async.wait
	}
	getMode_request {
		_prGtkToggleButtonGetMode;
		^this.primitiveFailed
	}

	setActive {
		arg value = true;
		this.setActive_request(value);
		Async.wait
	}
	setActive_request {
		arg value;
		_prGtkToggleButtonSetActive;
		^this.primitiveFailed
	}

	getActive {
		this.getActive_request;
		^Async.wait
	}
	getActive_request {
		_prGtkToggleButtonGetActive;
		^this.primitiveFailed
	}

	setInconsistent {
		arg value = true;
		this.setInconsistent_request(value);
		Async.wait
	}
	setInconsistent_request {
		arg value;
		_prGtkToggleButtonSetInconsistent;
		^this.primitiveFailed
	}

	getInconsistent {
		this.getInconsistent_request;
		^Async.wait
	}
	getInconsistent_request {
		_prGtkToggleButtonGetInconsistent;
		^this.primitiveFailed
	}

	// Extra
	*newWithTwoLabels {
		arg label1, label2, cb1, cb2;
		var button;
		
		button = GtkToggleButton.newWithLabel(label1);
		button.connect('toggled', {
			var value;
			value = button.getActive;
			if (value, {
				button.setLabel(label2);
				cb2.value(value);
			}, {
				button.setLabel(label1);
				cb1.value(value);
			});
		});
		^button
	}
	*newYesNo {
		^GtkToggleButton.newWithTwoLabels('Yes', 'No');
	}
	*newNoYes {
		^GtkToggleButton.newWithTwoLabels('No', 'Yes');
	}
	*newEnabledDisabled {
		^GtkToggleButton.newWithTwoLabels('Enabled', 'Disabled');
	}

	*newWithTwoImages {
		arg label1, label2;
		var button;
		
		button = GtkToggleButton.newWithLabel(label1);
		button.connect('toggled', {
			if (button.getActive, {
				button.setLabel(label2);
			}, {
				button.setLabel(label1);
			});
		});
		^button
	}

	toggle { this.setActive(this.getActive.not) }
}
