GtkTreeRowReference {
	var <>ptr;
	var finalizer;

	*new {
		arg model, path;
		^super.new.initGtkTreeRowReference(model, path);
	}
	initGtkTreeRowReference {
		arg model, path;
		this.newGtkTreeRowReference_request(model, path);
		this.wrap(Async.wait)
	}
	newGtkTreeRowReference_request {
		arg model, path;
		_prGtkTreeRowReferenceNew;
		^this.primitiveFailed
	}

	*wrap {
		arg inPtr;
		^super.new.wrap(inPtr);
	}
	wrap {
		arg inPtr;
		ptr = inPtr;
	}

	getPath {
		this.getPath_request;
		^Async.wait
	}
	getPath_request {
		_prGtkTreeRowReferenceGetPath;
		^this.primitiveFailed
	}

	valid {
		this.valid_request;
		^Async.wait
	}
	valid_request {
		_prGtkTreeRowReferenceValid;
		^this.primitiveFailed
	}

	free {
		this.free_request;
		Async.wait;
		ptr = 0;
	}
	free_request {
		_prGtkTreeRowReferenceFree;
		^this.primitiveFailed
	}

	copy {
		this.copy_request;
		^GtkTreeRowReference.wrap(Async.wait)
	}
	copy_request {
		_prGtkTreeRowReferenceCopy;
		^this.primitiveFailed
	}

	isValid {
		^(ptr != 0)
	}

	// Extra

	*newFromIndices {
		arg model, indices;
		var path, ref;
		path = GtkTreePath.newFromIndices(model, indices);
		ref = super.new.initGtkTreeRowReference(model, path);
		^ref
	}
	getIter {
		arg model;
		var path, iter;
		path = this.getPath;
		iter = model.getIter(path);
		^iter
	}
}
