GtkTreeView : GtkContainer {
	*new {
		this.newGtkTreeView_request;
		^super.new.wrap(Async.wait)
	}
	*newGtkTreeView_request {
		_prGtkTreeViewNew;
		^this.primitiveFailed;
	}	

	*newWithModel {
		arg model;
		this.newGtkTreeViewWithModel_request(model);
		^super.new.wrap(Async.wait)
	}
	*newGtkTreeViewWithModel_request {
		arg model;
		_prGtkTreeViewNewWithModel;
		^this.primitiveFailed;
	}

	setRulesHint {
		arg value = true;
		this.setRulesHint_request(value);
		Async.wait
	}
	setRulesHint_request {
		arg value = true;
		_prGtkTreeViewSetRulesHint;
		^this.primitiveFailed;
	}

	setSearchColumn {
		arg n = 0;
		this.setSearchColumn_request(n);
		Async.wait
	}
	setSearchColumn_request {
		arg n = 0;
		_prGtkTreeViewSetSearchColumn;
		^this.primitiveFailed;
	}

	appendColumn {
		arg column;
		this.appendColumn_request(column);
		Async.wait
	}
	appendColumn_request {
		arg column;
		_prGtkTreeViewAppendColumn;
		^this.primitiveFailed;
	}

	getSelection {
		this.getSelection_request;
		^GObject.wrap(Async.wait)
	}
	getSelection_request {
		_prGtkTreeViewGetSelection;
		^this.primitiveFailed;
	}

	setReorderable {
		arg value = true;
		this.setReorderable_request(value);
		Async.wait
	}
	setReorderable_request {
		arg value = true;
		_prGtkTreeViewSetReorderable;
		^this.primitiveFailed;
	}

	getReorderable {
		this.getReorderable_request;
		^Async.wait
	}
	getReorderable_request {
		_prGtkTreeViewGetReorderable;
		^this.primitiveFailed;
	}

	enableModelDragSource {
		arg startButtonMask, targets, actions;
	
		startButtonMask = startButtonMask ? 'modifier-mask';
		targets = targets ? [GtkTargetEntry.new('GTK_TREE_MODEL_ROW')];
		actions = actions ? ['copy', 'move'];

		this.enableModelDragSource_request(startButtonMask, targets, actions);
		Async.wait
	}
	enableModelDragSource_request {
		arg startButtonMask, targets, actions;
		_prGtkTreeViewEnableModelDragSource;
		^this.primitiveFailed;
	}

	enableModelDragDest {
		arg targets, actions;

		targets = targets ? [GtkTargetEntry.new('GTK_TREE_MODEL_ROW')];
		actions = actions ? ['copy', 'move'];

		this.enableModelDragDest_request(targets, actions);
		Async.wait
	}
	enableModelDragDest_request {
		arg targets, actions;
		_prGtkTreeViewEnableModelDragDest;
		^this.primitiveFailed;
	}

	getDestRowAtPos {
		arg x, y;
		this.getDestRowAtPos_request(x, y);
		^Async.wait
	}
	getDestRowAtPos_request {
		arg x, y;
		_prGtkTreeViewGetDestRowAtPos;
		^this.primitiveFailed;
	}

	expandRow {
		arg path, openAll = true;
		this.expandRow_request(path, openAll);
		Async.wait
	}
	expandRow_request {
		arg path, openAll;
		_prGtkTreeViewExpandRow;
		^this.primitiveFailed;
	}

	expandAll {
		this.expandAll_request;
		Async.wait		
	}
	expandAll_request {
		_prGtkTreeViewExpandAll;
		^this.primitiveFailed;
	}

	getModel {
		this.getModel_request;
		^GObject.wrap(Async.wait)		
	}
	getModel_request {
		_prGtkTreeViewGetModel;
		^this.primitiveFailed;
	}

	scrollToCell {
		arg pathOrIter, column, rowAlign, colAlign;
		var path;

		if (pathOrIter.isKindOf(GtkTreeIter), {
			path = this.getModel.getPath(pathOrIter)
		}, {
			path = pathOrIter
		});

		this.scrollToCell_request(path, column, rowAlign, colAlign);
		Async.wait;
	}
	scrollToCell_request {
		arg path, column, rowAlign, colAlign;
		_prGtkTreeViewScrollToCell;
		^this.primitiveFailed;
	}

	// Extra
	enableCustomDragAndDrop {
		arg dropfunction, canDragFunction;

		this.enableModelDragSource;
		this.enableModelDragDest;

		this.connect('drag-data-received', {
			arg treeview, dc, x, y, data, info, time;
			var dest, ptr, oldpath, newpath, position;

			if (treeview.notNil, {
				//Post << "DDR: " << [treeview, dc, x, y, data, info, time] << "\n";
				ptr = data.getAsPointer;
				if (ptr.notNil and: { ptr != 0 }, {
					oldpath = GtkTreePath.wrap(ptr, GType.new("GtkTreePath").id);
				});

				dest = treeview.getDestRowAtPos(x, y);
				if (dest.notNil, { #newpath, position = dest; });

				if (oldpath.notNil, {
					dropfunction.value(oldpath, position, newpath);
				});
			});
		});
		this.connect('drag-data-get', {
			arg treeview, dc, data, info, time;
			var canDrag, rowref, path;

			if (treeview.notNil, {
				//Post << "DDG: " << [treeview, dc, data, info, time] << "\n";
				rowref = GtkTreeRowReference.wrap(dc.getData('gtk-tree-view-source-row'));

				if (rowref.isValid, {
					path = rowref.getPath;

					if (canDragFunction.isNil or: { canDragFunction.value(path) }, {
						canDrag = true;
					}, {
						canDrag = false;
					});

					if (canDrag, {
						data.setToPointer(path.steal);
					}, {
						data.setToPointer(0);
					});
				});
			}, {
				"Missing drag-data-get event".warn;
			});
		});

	}
}
