+ Object {
	gui {
		nil
	}
}

+ Array {
	asGtkVBox {
		arg homo = false, spacing = 0, box;

		box = box ?? { GtkVBox.new(homo, spacing) };

		this.do({
			arg child;
			box.add(child);
			child.show;
		});

		^box		
	}
	asGtkHBox {
		arg homo = false, spacing = 0, box;

		box = box ?? { GtkHBox.new(homo, spacing) };

		this.do({
			arg child;
			box.add(child);
			child.show;
		});

		^box		
	}

	asButtons {
		^this.collect({
			arg item;
			var button;

			button = GtkButton.newWithLabel(item.key);
			button.connect('clicked', item.value);

			button
		})
	}
}

+ Dictionary {
	gui {
		var box, itemFrame, itemGui;

		box = GtkVBox.new(false, 0);
		box.show;

		this.keysValuesDo({
			arg name, item;

			itemGui = item.gui;
			if (itemGui.notNil, {
				itemFrame = GtkFrame.new(name);
				itemFrame.show;
				box.packStart(itemFrame, false, false, 0);
			
				itemGui.show;
				itemFrame.add(itemGui);
			});
		});

		^box
	}
}

+ Patch {
	deepGui {
		^GtkPatchView(this, inf)
	}
	gui {
		^GtkPatchView(this)
	}
}

+ SimpleTrigger {
	gui {
		arg name;
		^GtkTrigPlayerView(name, this) 
	}
}

+ KrNumberEditor {
	gui {
		arg name;
		^GtkNumberEditorView(name, this) 
	}
}

+ Recorder {
	gui {
		^GtkRecorderView(this)
	}
}

+ AudioInPlayer {
	gui {
		^GtkLabel.new("No GUI available for object of kind" + this.class)
	}
}

+ SoundSystem {
	gui { ^GtkSoundSystemView(this) }
}

+ ActionScript {
	gui { ^GtkActionScriptView(this) }
}
