GtkRecorderView : GtkVBox {
	var recorder, <>freeOnDestroy;
	var filenameLabel, button;

	*new {
		arg aRecorder;
		^super.new(false, 0).initGtkRecorderView(aRecorder)
	}
	initGtkRecorderView {
		arg aRecorder;
		var label;

		freeOnDestroy = true;
		recorder = aRecorder;

		filenameLabel = GtkLabel.new(recorder.filename);
		this.packStart(filenameLabel, true, true, 0);		

		button = GtkToggleButton.newWithTwoLabels("Stopped", "Recording");
		button.setActive(recorder.isRunning);
		button.connect('toggled', {
			if (button.getActive, {
				recorder.start;
			}, {
				recorder.stop;
			});
		});
		this.packStart(button, true, true, 0);

		if (recorder.ready.not, {
			this.setSensitive(recorder.ready);
			Gtk.timeoutAdd(250, {
				if (recorder.ready, {
					this.setSensitive(true);
					false
				}, {
					true
				});
			});
		});

		this.showAllChildren;
	}

	finalize {
		if (freeOnDestroy, {
			recorder.stop;
			recorder.free;
		});
	}

	defaultSizeAsToplevel {	^#[320, 200] }
}
