ControlConstraint {
	var <patch, <iargs, <changeFunctions, <updateFunction, <>spec, <>value;
	var <mode, <auto;
	var oargs;

	*new {
		arg patch, iargs, changeFunctions, updateFunction, spec, value;
		spec = spec.asSpec;
		^super.newCopyArgs(patch, iargs, changeFunctions, updateFunction, spec, value).initMultiEditor
	}

	initMultiEditor {
		oargs = changeFunctions.collect({ arg item; item.key });
		iargs = iargs ? oargs.copy;

		iargs = this.getRealArgs(iargs);
		oargs = this.getRealArgs(oargs);

		changeFunctions = changeFunctions.collectAs({ arg item, i; (oargs[i] -> item.value)}, IdentityDictionary);

		iargs.do({ arg anArg; anArg.addDependant(this) });

		value = updateFunction.valueArray(iargs);

		auto = true;
		mode = \active;
	}

	changed {
		arg changer;

		if (auto and: {oargs.includes(changer).not and: { iargs.includes(changer).not }}, { mode = \active });

		if (mode === \active or: { oargs.includes(changer).not }, {
			this.updateOutputs;
		});

		^super.changed(changer)
	}

	update {
		arg changed, changer;

		if (changer === this, { ^this });

		//value = updateFunction.valueArray(iargs);

		if (auto and: {oargs.includes(changed)}, { mode = \passive });

		if (mode === \active and: { oargs.includes(changed).not}, {
			this.updateOutputs;			
		});

		if (mode === \passive, {
			value = updateFunction.valueArray(iargs);
			this.changed(changed);
		});
	}

	updateOutputs {
		var newvalue;

		changeFunctions.keysValuesDo({
			arg oarg, function;

			newvalue = oarg.spec.constrain(function.valueArray([value] ++ iargs));

			if (newvalue.notNil, {
				oarg.value_(newvalue).changed(this);
			});
		});		
	}

	mode_ {
	}
	auto_ {
	}
	
	// This is not called at all...
	finalize {
		iargs.do({ arg anArg; anArg.removeDependant(this) });
	}

	getRealArgs {
		arg args;
		^args.collect({
			arg anArg;
			var realArg, index;

			index = if (anArg.isNumber, { index }, { patch.argNamesForSynth.indexOf(anArg.asSymbol) });

			if (index.notNil, {
				realArg = patch.argsForSynth[index]
			});
			
			if (realArg.isNil, {
				error("bad argument specifier" + anArg);
				this.verboseHalt
			});

			realArg
		});
	}

	argName {
		arg item;
		var index;

		index = patch.argsForSynth.indexOf(item);
		if (index.isNil, { ^item.asString });
		^patch.argNamesForSynth[index].asString
	}
}
