MusicProcess {
	var <function, <args, <trigger;
	var <routine;

	*new {
		arg function, args, trigger;
		^super.newCopyArgs(function, args, trigger).init
	}

	init {
		var index;

		args = args ? [];

		if (args.size < function.def.argNames.size, {
			args = args ++ Array.fill(function.def.argNames.size - args.size, nil);
		});
		args = args.collect({
			arg item, index;

			case([
				{ item.isNil } -> { function.def.argNames[index].asSpec.defaultControl },
				{ item.isKindOf(ControlSpec) } -> { item.defaultControl	},
				{ item.isArray } -> { item.asSpec.defaultControl }
			], { item });
		});

		routine = RoutineWithEnvironment({
			function.valueArray(args)
		});

		if (trigger.isNil, {
			trigger = KrNumberEditor(0.0);
		});

		trigger.action = {
			arg value;
			if (value > 0.0, {
				this.start;
			}, {
				this.stop;
			});
		};
	}

	controlOf {
		arg index;

		index = if (index.isNumber, { index }, { function.def.argNames.indexOf(index) });
		if (index.isNil, { ^nil });
		^args[index]
	}

	start {
		this.stop;
		routine.reset;
		routine.play;
	}
	stop {
		routine.stop;
	}
}
