SoundSystem {
	var <patch, <environment;

	*new {
		arg function;
		^super.new.init.define(function)
	}
	init {
		environment = Environment.new;
	}
	define {
		arg function;
		patch = environment.use(function);
	}
	inside {
		arg function;
		^environment.use(function)
	}

	patches {
		^environment.select({ arg name, item; item.isKindOf(Patch) });
	}

	play {
		patch.play;
	}
	stop {
		patch.stop;
	}	

	at { arg symbol; ^environment.at(symbol) }
	put { arg symbol; ^environment.at(symbol) }
	getattr { arg symbol; ^environment.at(symbol) }
	setattr { arg symbol, value; environment.put(symbol, value) }

	spec {
		arg ...path;
		^this.childFromPath(path).spec
	}

	control {
		arg ...path;
		^this.childFromPath(path)
	}

	directControl {
		arg ...path;
		var name, object, index, node, control;

		name = path.pop;

		object = this.childFromPath(path);
		if (object.isNil or: { object.isKindOf(Patch).not }, {
			^nil
		});

		node = object.synth;

		index = if (name.isNumber, {
			name
		}, {
			object.indexFromName(name)
		});

		index = object.synthArgsIndices[index];
		if (index.isNil, { ^nil });

		control = NodeControl(node, index);
		if (name.isNumber.not, { control.name = name });

		^control
	}

	childFromPath {
		arg path;
		var object;

		object = patch;
		path.do({
			arg i, index;

			if (object.isNil or: { object.isKindOf(Patch).not }, {
				error("Object at." + index + "is not a Patch");
				this.verboseHalt;
			});

			if (i.isNumber, {
				object = object.argsForSynth[i];
			}, {
				i = object.synthArgsIndices[object.indexFromName(i)];
				if (i.isNil, { ^nil });
				object = object.argsForSynth[i];
			});
			if (object.isNil, { ^nil });
		});
		^object
	}
}
