Spectrum {
	var <freqs, <amps;
	*new {
		arg n = 32, freqs, amps;
		^super.new.initSpectrum(n, freqs, amps)
	}
	initSpectrum {
		arg n, someFreqs, someAmps;
		freqs = someFreqs ? Array.fill(n ? 32, 0.0);
		amps = someAmps ? Array.fill(n ? 32, 0.0);
	}

	*with {
		arg freqs, amps;
		^this.new(nil, freqs, amps)
	}

	*mcAdams {
		arg amps, type = \random, coeff = \random;
		^this.with(this.mcAdamsFreqs(amps.size, type, coeff), amps)
	}

	*random {
		arg n = 32, type = \random, coeff = \random, ampexp = 3.0;
		var amps, freqs;
		
		amps = if (ampexp == \comb, { Array.rand(n, 0, 1) }, { Array.rand(n, 0.0, 1.0).pow(ampexp) });
		freqs = this.mcAdamsFreqs(n, type, coeff);

		^this.with(freqs, amps)
	}

	n { ^min(freqs.size, amps.size) }

	asArray { ^Array.fill(this.n, { |i| [freqs[i], amps[i]] }).flat }

	*mcAdamsFreqs {
		arg n = 32, type = \random, coeff = \random;
		var freqs;
		
		type = if (type == \random, { [\harmonic, \compressed, \expanded].choose }, { type });
		coeff = if (coeff == \random, { rrand(0.0, 3.0) }, { coeff });

		case([
			{ type == \harmonic }	-> { freqs = Array.fill(n, { |i| i + 1 }) },
			{ type == \expanded }	-> { freqs = Array.fill(n, { |i| (i + 1).pow(coeff) }) },
			{ type == \compressed}	-> { freqs = Array.fill(n, { |i| (i + 1).pow(1.0/coeff) }) }
		]);

		^freqs
	}
}
