OSCmanager {
	classvar <>synthdefs;

	*initClass {
		synthdefs = Dictionary.new;
	}

	*add {
		arg synthdef;
		synthdefs.put(synthdef.name, synthdef);
		(synthdef.name + "added").postln;
	}

	*createControls {
		arg addr, synth, synthname = nil, n = nil; 
		var synthdef, responders;

		responders = Set.new;

		synthdef = synthdefs.at(synth.defName);
		if(synthdef !== nil, {
			synthdef.controlNames.do({
				arg controlName;
				var resp, cmd;

				cmd = "/" ++ synth.defName ++ "/" ++ controlName.name;

				resp = OSCresponder(addr, cmd, {
					arg time, resp, msg;
					synth.set(controlName.name, msg.at(1));
				}).add;

				responders.add(resp);
			});
		});

		^responders;
	}

	*createGroupControls {
		arg addr, group, synthdefname, name = nil, n = nil; 
		var synthdef, responders;

		responders = Set.new;

		synthdef = synthdefs.at(synthdefname.asString);
		name = name ? synthdefname;

		if (synthdef !== nil, {
			("building controls for synthdef" + synthdef.name).postln;
			synthdef.controlNames.do({
				arg controlName;
				var resp, cmd;

				cmd = "/" ++ name ++ "/" ++ controlName.name;
				("new OSC responder:" ++ cmd).postln;

				resp = OSCresponder(addr, cmd, {
					arg time, resp, msg;
					group.set(controlName.name, msg.at(1));
				}).add;

				responders.add(resp);
			}, {
				("No synthdef found for " ++ synthdefname).postln;
			});
		});

		^responders;
	}

	*destroyControls {
		arg responders;

		if (responders !== nil, {
			responders.do({
				arg resp;
				OSCresponder.remove(resp);
			});
			responders.makeEmpty;
		});
		^nil;
	}
}

