Markov {
	var matrix, <>current;
	*new {
		^super.new.initMarkov
	}
	initMarkov {
		arg n;
		matrix = Array2D.new(n, n).with(Array.fill(n * n, 1.0 / n))
	}
	next {
		current = rowAt(current).windex;
		^current
	}
	size { matrix.rows }
	at { |i, j| ^matrix[i, j] }
	put { |i, j, value| matrix[i, j] = value }
}

MarkovLoader {
	var m, umatrix, previous;
	*new {
		arg m;
		^super.newCopyArgs(m).initMarkovLoader
	}
	initMarkovLoader {
		umatrix = Array2D.new(m.size, m.size).with(Array.fill(m.size * m.size, 0))
	}
	add {
		arg current;
		if (previous.notNil, {
			umatrix[previous, current] = umatrix[previous, current] + 1;
			umatrix.rowAt(previous).normalizeSum.do({
				arg value, j;
				m[previous, j] = value;
			});
		});
		previous = current;
	}
}
