+ Object {
	watch {
		arg class, object, function, position = 'tail', mode = 'normal';
		var allMyReactions, reactions, reaction, watchersOfObject, watchersOfObjectForClass;

		var emittedClasses, found;

		if (mode == 'async', {
			function = function.asAsync;
		});

		if (ObjectSignals.checkEnabled, {
			if (ObjectSignals.classEmitsClass(object.class, class).not, {
				error("unknown signal class '" ++ class.asString ++ "' for source class "
					 ++ object.class.asString);
				this.verboseHalt;
			});
		});

		allMyReactions = ObjectSignals.allReactions.at(this);
		if (allMyReactions.isNil, {
			allMyReactions = IdentityDictionary.new;
			ObjectSignals.allReactions.put(this, allMyReactions);
		});

		reactions = allMyReactions.at(class);
		if (reactions.isNil, {
			reactions = IdentityDictionary.new;
			allMyReactions.put(class, reactions);
		});

		if (function.isKindOf(Symbol), {
			reaction = MethodReaction.new(function);
		}, {
			reaction = FunctionReaction.new(function);
		});

		reactions.put(object, reaction);
		
		watchersOfObject = ObjectSignals.allWatchers.at(object);
		if (watchersOfObject.isNil, {
			watchersOfObject = IdentityDictionary.new;
			ObjectSignals.allWatchers.put(object, watchersOfObject);
		});

		watchersOfObjectForClass = watchersOfObject.at(class);
		if (watchersOfObjectForClass.isNil, {
			watchersOfObjectForClass = Array.new(1);
			watchersOfObject.put(class, watchersOfObjectForClass);
		});

		// Should be 'head' or 'tail'
		if (watchersOfObjectForClass.includes(this), {
			watchersOfObjectForClass.remove(this);
		});
		if (position == 'head', {
			watchersOfObject.put(class, watchersOfObjectForClass.insert(0, this));
		}, {
			watchersOfObject.put(class, watchersOfObjectForClass.add(this));
		});

		^reaction
	}

	watchDeferred {
		arg class, object, function, position = 'tail';
		^this.watch(class, object, function, position);
		//^this.watch(class, object, { arg ...args; {  function.value(args) }.defer }, position);
	}
	watchSyncDeferred {
		arg class, object, function, position = 'tail';
		//^this.watch(class, object, { arg ...args; function.syncdeferArray(args) }, position);
		^this.watch(class, object, function, position);
	}

	forgetEverything {
		var allMyReactions, reactions, watchersOfObject, watchersOfObjectForClass;

		allMyReactions = ObjectSignals.allReactions.removeAt(this);

		if (allMyReactions.notNil, {
			allMyReactions.keysValuesDo({
				arg class, reactions;
				reactions.keysDo.do({
					arg object;

					watchersOfObject = ObjectSignals.allWatchers.at(object);
					if (watchersOfObject.notNil, {
						watchersOfObjectForClass = watchersOfObject.at(class);
						if (watchersOfObjectForClass.notNil, {
							watchersOfObjectForClass.remove(this);
							if (watchersOfObjectForClass.size == 0, {
								watchersOfObject.removeAt(class);
							});
						});
					});
					if (watchersOfObject.size == 0, {
						ObjectSignals.allWatchers.removeAt(object);
					});			
				});
			});
		});
	}

	forget {
		arg object, class;
		var allMyReactions, reactions, watchersOfObject, watchersOfObjectForClass;
		var classes, emptycount;

		// Forget by object
		if (object.notNil, {
			allMyReactions = ObjectSignals.allReactions.at(this);
			//Post << thisMethod.asString << "(1): " << allMyReactions << "\n";
			if (allMyReactions.notNil, {
				classes = [];
				emptycount = 0;
				allMyReactions.keysValuesDo({
					arg class, reactions;
					//Post << thisMethod.asString << "(2): " << class.asString << "\n";
					classes = classes.add(class);
					reactions.removeAt(object);
					if (reactions.size == 0, {
						emptycount = emptycount + 1;
					});
				});
				if (allMyReactions.size == 0 or: {emptycount == allMyReactions.size}, {
					ObjectSignals.allReactions.removeAt(this);
				});
			});
			//Post << thisMethod.asString << "(4): " << classes.asString << "\n";

			watchersOfObject = ObjectSignals.allWatchers.at(object);
			if (watchersOfObject.notNil, {
			//Post << thisMethod.asString << "(5): " << watchersOfObject << "\n";
				classes.do({
					arg class;
					//Post << thisMethod.asString << "(6): " << class << "\n";
					watchersOfObjectForClass = watchersOfObject.at(class);
					if (watchersOfObjectForClass.notNil, {
					//Post << thisMethod.asString << "(7): " << watchersOfObjectForClass << "\n";
						watchersOfObjectForClass.remove(this);
						if (watchersOfObjectForClass.size == 0, {
							watchersOfObject.removeAt(class);
						});
					});
				});
				if (watchersOfObject.size == 0, {
					ObjectSignals.allWatchers.removeAt(object);
				});
			});
		});

		// Forget by class
		if (class.notNil, {
			// NOT YET IMPLEMENTED
		});
	}

	emit {
		arg event... args;
		var eventIsSymbol, class, watchersOfObject, watchersOfObjectForClass;
		var allMyReactions, reactions, reaction;

		eventIsSymbol = event.isKindOf(Symbol);
		if (eventIsSymbol, {
			class = event;
		}, {
			class = event.class;
		});

		watchersOfObject = ObjectSignals.allWatchers.at(this);
		if (watchersOfObject.notNil, {
			watchersOfObjectForClass = watchersOfObject.at(class);
			if (watchersOfObjectForClass.notNil, {
				watchersOfObjectForClass.do({
					arg target;

					allMyReactions = ObjectSignals.allReactions.at(target);
					if (allMyReactions.notNil, {
						reactions = allMyReactions.at(class) ? allMyReactions.at(Anything);
						if (reactions.notNil, {
							reaction = reactions.at(this);
							if (eventIsSymbol, {
								reaction.perform(args);
							}, {
								reaction.perform([event] ++ args); 
							});
						});
					});
				});
			});
			watchersOfObjectForClass = watchersOfObject.at(Anything);
			if (watchersOfObjectForClass.notNil, {
				watchersOfObjectForClass.do({
					arg target;

					allMyReactions = ObjectSignals.allReactions.at(target);
					if (allMyReactions.notNil, {
						reactions = allMyReactions.at(class) ? allMyReactions.at(Anything);
						if (reactions.notNil, {
							reaction = reactions.at(this);
							if (eventIsSymbol, {
								reaction.perform(args);
							}, {
								reaction.perform([event] ++ args); 
							});
						});
					});
				});
			});
		});
	}
}
