Reaction {
	var <>locked;

	*new {
		^super.new.initReaction
	}
	initReaction {
		locked = false;
	}
	perform {
		^this.subclassResponsibility
	}
}

FunctionReaction : Reaction {
	var <function;

	*new {
		arg inFunction;
		^super.new.initFunctionRection(inFunction);
	}
	initFunctionRection {
		arg inFunction;
		function = inFunction;
	}
	perform {
		arg args;
		if (locked, {
			^nil
		}, {
			^function.valueArray(args)
		});
	}
}

MethodReaction : Reaction {
	var <method;

	*new {
		arg inMethod;
		^super.new.initMethodReaction(inMethod);
	}
	initMethodRection {
		arg inMethod;
		method = inMethod;
	}
	perform {
		arg object, args;
		if (locked, {
			^nil
		}, {
			^object.performList(method, args)
		});
	}
}
