SynthDefStore {
	classvar <server, <synthdefs, routine, <>enabled = true;

	*initClass {
		server = Server.default;
		synthdefs = IdentityDictionary[];
	}

	*at { |name| ^synthdefs[name.asSymbol] }

	*add {
		arg synthdef;

		synthdefs[synthdef.name.asSymbol] = synthdef;

		if (enabled, {
			if (synthdefs.size == 1, {
				routine = Routine({
					var serverRunning = false;
					loop({
						if (serverRunning.not, {
							if (server.serverRunning, {
								this.sendAll;
							});
						});
						serverRunning = server.serverRunning;
						0.5.yield;
					});
				});
				routine.play(AppClock);
			}, {
				if (server.serverRunning, {
					Post << "Sending synthdef " << synthdef.name.asString << nl;
					synthdef.send(server);
				});
			});
		}, {
			synthdef.send(server);
		});
	}

	*server_ {
		arg s;
		server = s;
		this.sendAll;
	}

	*sendAll {
		synthdefs.values.do({
			arg synthdef;
			Post << "Sending synthdef " << synthdef.name.asString << nl;
			synthdef.send(server);
		})
	}
}
