GtkCollapsableFrame : GtkVBox {
	var <childBox, childFrame, childButtonBox, expandButton, <child;
	var <collapsedBox, collapsedChild, collapsedLabel, collapseButton;

	*new {
		arg name, child, expanded = true;
		^super.new.initGtkCollapsableFrame(name, child, expanded)
	}
	initGtkCollapsableFrame {
		arg name, child, expanded;

		childFrame = GtkFrame(name);
		this.packStart(childFrame, true, true);

		childBox = GtkVBox.new;
		childFrame.add(childBox);
		childBox.show;

		childButtonBox = GtkHBox.new;
		childBox.packStart(childButtonBox, false, false);
		childButtonBox.show;

		collapseButton = GtkButton.newWithStockImage('gtk-remove', 'small-toolbar', callback: { this.collapse });
		childButtonBox.packEnd(collapseButton, false, false);
		collapseButton.show;

		collapsedBox = GtkVBox.new;
		this.packStart(collapsedBox, false, false);

		collapsedChild = GtkHBox.new;
		collapsedBox.packStart(collapsedChild, false, false);
		collapsedChild.show;

		collapsedLabel = GtkLabel.new(name ++ " (collapsed)", 0.5, 0.0);
		collapsedLabel.show;
		collapsedChild.packStart(collapsedLabel, true, true);

		expandButton = GtkButton.newWithStockImage('gtk-add', 'small-toolbar', callback: { this.expand });
		collapsedChild.packEnd(expandButton, false, false);
		expandButton.show;

		this.add(child);
		if (expanded, { this.expand }, { this.collapse });
	}

	showAllChildren {
	}
	showAll {
		this.show;
	}

	add {
		arg aChild;
		if (aChild.notNil, {
			child = aChild;
			childBox.packEnd(child, true, true);
			child.show;
		});
	}

	expand {
		if (child.notNil, {
			collapsedBox.hide;
			childFrame.show;
		});
	}

	collapse {
		collapsedBox.show;
		childFrame.hide;		
	}	
}