GtkColorButton : GtkButton {
	var eventbox, <color, popup;

	*new {
		arg inColor;
		^super.new.initGtkColorButton(inColor)
	}
	initGtkColorButton {
		arg inColor;

		this.setSizeRequest(-1, 24);

		eventbox = GtkEventBox.new;
		this.add(eventbox);
		this.color = inColor ?? { GdkColor.red };

		popup = GtkSimpleColorSelectionPopup.new;
		popup.setHideOnDelete;
		popup.selection.setHasOpacityControl(false);
		popup.selection.setUpdatePolicy('discontinuous');
		popup.selection.connect('color-changed', {
			arg selection;
			this.color = selection.getCurrentColor;
		});

		this.connect('clicked', {
			var toplevel;
			toplevel = this.getToplevel;
			if (toplevel.notNil and: { toplevel.isToplevel }, {
				popup.setTransientFor(toplevel);
				popup.setDestroyWithParent;
			});
			popup.show;
		});
	}
	color_ {
		arg aColor;
		if (aColor.notNil, {
			color = aColor;
			eventbox.modifyBg('normal', color);
			eventbox.modifyBg('prelight', color);
			eventbox.modifyBg('active', color);
		});
	}

	finalize {
		popup.destroy;
	}
}
