GtkConsole : GtkVBox {
	var paned, outputView, inputNotebook , buttonBox;
	var outputBuffer;
	var inputViews;

	var <sidebarChildren;
	
	var postedConnection;

	*new {
		^super.new(false, 0).init;
	}
	init {
		var scrolled;

		paned = GtkVPaned.new;
		this.packStart(paned, true, true, 0);

		scrolled = GtkScrolledWindow.new;
		scrolled.setPolicy(\automatic, \automatic);		
		paned.pack1(scrolled, true, true);
		
		outputView = GtkTextView.newWithBuffer(GtkConsoleOutputBuffer.get);
		outputView.setEditable(false);
		scrolled.add(outputView);

		GtkConsoleOutputBuffer.get.connect('changed', {
			//arg buffer, iter;
			//if (iter.isEnd, {
			{ outputView.scrollAtEnd }.syncdefer;
			//});
			false
		});
		outputView.scrollToEnd;

		inputNotebook = GtkNotebook.new;
		paned.pack2(inputNotebook, true, true);

		inputViews = Array.new;

		outputBuffer = outputView.getBuffer;

		this.addCodeView;

		this.setSeparatorPosition(300);
		this.showAllChildren(true);
	}

	setSeparatorPosition {
		arg value;
		paned.setPosition(value);
	}

	addCodeView {
		arg title = "Untitled";
		var iview;

		iview = GtkSCCodeView.new(this);
		inputViews = inputViews.add(iview);
		inputNotebook.appendPageWithText(iview, title);
		iview.show;
	}

	updateDisplayValuesLayout {
	}

	finalize {
		^super.finalize
	}
}
