GtkDictionaryBrowser : GtkHBox {
	var sw, model, treeview, itemframe;
	var dict;

	var selection;

	*new {
		arg dictionary, homogeneous = false, spacing = 0;
		^super.new(homogeneous, spacing).initGtkDictionaryBrowser(dictionary)
	}
	initGtkDictionaryBrowser {
		arg dictionary;
		var paned, renderer, column;

		dict = dictionary;

		paned = GtkHPaned.new;
		paned.setPosition(200);
		this.packStart(paned, true, true, 0);

		sw = GtkScrolledWindow.new;
		sw.setShadowType("etched-in");
		sw.setPolicy(\never, \automatic);
		paned.pack1(sw, true, true);

		model = GtkListStore.new(\gchararray);

		dict.keysDo({
			arg key, value, i;
			model.set(model.append, 0 -> key.asString);
		});

		treeview = GtkTreeView.newWithModel(model);
		treeview.setSearchColumn(0);
		sw.add(treeview);

		renderer = GtkCellRendererText.new;
		column = GtkTreeViewColumn.newWithAttributes("Name", renderer, "text", 0);
		treeview.appendColumn(column);

		itemframe = GtkFrame.new;
		paned.pack2(itemframe, true, true);

		selection = treeview.getSelection;
		selection.connect("changed", {
			arg object ...args;
			this.updateItemFrame;
		});

		this.updateItemFrame;

		this.showAllChildren;
	}
	updateItemFrame {
		var iter, key, item, view;

		iter = selection.getSelected;
		if (iter.notNil, {
			key = model.getValue(iter, 0);

			item = dict.at(key);
			view = item.createGtkView(dict, key);

			view = view ? GtkLabel.new("Not editable");

			itemframe.removeChild;
			itemframe.add(view);
			itemframe.setLabel(key);
			view.showAll;
		});
	}
}
