GtkDrawableArea : GtkSensitiveArea {
	var hasAllocatedResources;
	var <drawCallQueue;

	var backgroundGC;

	*new {
		^super.new.initGtkDrawableArea
	}
	initGtkDrawableArea {
		hasAllocatedResources = false;

		this.addEvents('exposure-mask');
		this.connect('expose-event', {
			this.allocateResources;
			drawCallQueue.perform;
			false;
		});

		drawCallQueue = MethodCallQueue(this, { [window, width, height, backgroundGC] });
		drawCallQueue.add(\drawBackground, 100);
	}

	allocateResources {
		if (hasAllocatedResources || window.isNil, { ^this });

		backgroundGC = GdkGC.new(window);
		backgroundGC.setRgbFgColor("white");

		hasAllocatedResources = true;
	}

	backgroundColor_ { arg name; backgroundGC.setRgbFgColor(name) }
	drawBackground {
		window.drawRectangle(backgroundGC, true, 0, 0, width, height);
	}

	finalize {
		this.unrefAll([	backgroundGC ]);
		super.finalize;
	}
}
