GtkEnvelopeEditor : GtkMultiPackager {
	var <area, <presetView, <specCombo, <styleCombo;

	*new {
		arg maxPoints, points, minPoints, lockExtremes = \xAtEndPoints, label, presets;
		^super.new.initGtkEnvelopeEditor(maxPoints, points, minPoints, lockExtremes, label, presets)
	}
	initGtkEnvelopeEditor {
		arg maxPoints, points, minPoints, lockExtremes, aLabel, presets;
		var table, vbox, box, box2, state;
	
		this.label = aLabel;
		presets = presets ? Presets.new;

		area = GtkEnvelopeArea(maxPoints, points, minPoints, lockExtremes);
		presetView = GtkPresetView(presets, { area.state }, { |state| area.state = state });
		specCombo = GtkCombo.new;
		specCombo.setPopdownStringsList(["unipolar", "gain"]);
		specCombo.entry.setEditable(false);
		specCombo.entry.connect('changed', { area.yspec = specCombo.entry.getText.asSymbol });
		styleCombo = GtkCombo.new;
		styleCombo.setPopdownStringsList(Env.shapeNames.keys.collectAs({|name| name.asString}, Array));
		styleCombo.entry.setEditable(false);
		styleCombo.entry.connect('changed', { area.style = styleCombo.entry.getText.asSymbol });

		this.add(area, presetView, specCombo, styleCombo);

		this.addPackager(\normal, {
			var mainbox, vbox;

			mainbox = GtkHBox.new;

			area.size(\free);
			area.locked = false;
			mainbox.packStart(area, true, true);

			vbox = GtkVBox.new;
			mainbox.packEnd(vbox);

			presetView.switch(\normal);
			vbox.packStart(GtkLabel("Interpolation:"));
			vbox.packStart(styleCombo);
			vbox.packStart(GtkLabel("Y scale:"));
			vbox.packStart(specCombo);
			vbox.packEnd(presetView);

			vbox.showChildren;
			mainbox.showChildren;

			mainbox
		});
		defaultPackagerName = \normal; 

		this.addPackager(\display, {
			var mainbox;

			mainbox = GtkVBox.new;

			presetView.switch(\mini);
			mainbox.packStart(presetView, false, false);

			area.size(\mini);
			area.locked = true;
			mainbox.packEnd(area, true, true);
	
			mainbox.showAllChildren(false);

			mainbox
		});
	}
}
