GtkGroupAndElementSelector : GtkHBox {
	var <groups;
	var <groupSpinner, <elementSpinner;

	*initClass {
		ObjectSignals.register(this, #['selection-changed'])
	}
	*new {
		arg inGroups, action;
		^super.new.initGtkGroupAndElementSelector(inGroups, action)
	}

	initGtkGroupAndElementSelector {
		arg inGroups, action;
		var box, i, j;

		groups = inGroups;

		groupSpinner = GtkIntNumberBox(0, groups.nGroups - 1, {
			i = groupSpinner.value;
			elementSpinner.setRange(0, groups[i].size - 1);
			j = min(elementSpinner.value, groups[i].size);
			this.emit('selection-changed', i, j);
			action.value(i, j);
		});
	 	elementSpinner = GtkIntNumberBox(0, if (groups[0].notNil, {
			groups[0].size - 1
		}, {
			0
		}), {
			i = groupSpinner.value;
			j = min(elementSpinner.value, groups[i].size);
			this.emit('selection-changed', i, j);
			action.value(i, j);
		});

		this.watch('size-changed', groups, {
			var i;
			groupSpinner.setRange(0, groups.nGroups - 1);
			i = groupSpinner.value;
			elementSpinner.setRange(0, if (groups[i].notNil, { groups[i].size - 1}, { 0 }));
		}, mode: '\async');

		this.packMany([groupSpinner, elementSpinner])
	}

	pick_random_in_group {
		arg i, differand = true;

		if (i.notNil, {
			if (i != groupSpinner.value, { differand = false });
			groupSpinner.set(i)
		}, {
			i = groupSpinner.value
		});

		elementSpinner.value = if (differand, {
			groups[i].size.differand(elementSpinner)
		}, {
			groups[i].size.rand;
		});
	}
	pick_random { ^this.pick_random_in_group(groups.nGroups.differand(groupSpinner.value)) }

	element {
		var i;
		i = groupSpinner.value;
		if (groups[i].notNil, {
			^groups[i][min(elementSpinner.value, groups[i].size - 1)]
		}, {
			^nil
		});
	}

	bindKeys {
		arg grpdec, grpinc, elmdec, elminc;
		GtkPlusKbd.bindCombination(\press, grpdec, { groupSpinner.decrement });
		GtkPlusKbd.bindCombination(\press, grpinc, { groupSpinner.increment });
		GtkPlusKbd.bindCombination(\press, elmdec, { elementSpinner.decrement });
		GtkPlusKbd.bindCombination(\press, elminc, { elementSpinner.increment });
	}

	value { ^[groupSpinner.value, elementSpinner.value] }
	value_ { |ids| groupSpinner.set(ids[0]); elementSpinner.value = ids[1] }

	state { ^this.value }
	state_ { |x| this.value = x }

	finalize {
		this.forgetEverything;
		super.finalize;
	}
}
