GtkMultiGroupAndElementSelector : GtkMultiPackager {
	var selectors, rndButtons, rndInGrpButtons, allRndButton, allRndInGrpButton;

	*initClass {
		ObjectSignals.register(this, #['selection-changed'])
	}
	*new {
		arg groups, n, label;
		^super.new.initGtkMultiGroupAndElementSelector(groups, n, label)
	}

	initGtkMultiGroupAndElementSelector {
		arg groups, n, label;
		var selector, button, box;
	
		this.setLabel(label);

		this.prMakeWidgets(groups, n);

		this.addPackager(\normal, {
			var table, n;

			n = selectors.size;
			table = GtkTable(if (n > 1, { n + 1 }, { 1 }), 3);
			table.packArrays(
				selectors, [0, 0],
				rndButtons, [0, 0],
				rndInGrpButtons, [0, 0]
			);
			if (n > 1, {
				table.attach(allRndButton.show, 1, 2, n, n + 1);
				table.attach(allRndInGrpButton.show, 2, 3, n, n + 1);
			});

			table
		});
		defaultPackagerName = \normal;
	}

	prMakeWidgets {
		arg groups, n;		var selector, button1, button2; 

		selectors = Array.fill(n, {
			arg k;

			GtkGroupAndElementSelector(groups, {
				arg i, j;
				this.emit('selection-changed', k, i, j);
			});
		});
		rndButtons = Array.fill(n, {
			arg k;
			GtkTriggerButton("Rnd", { this.pick_random(k) });
		});
		rndInGrpButtons = Array.fill(n, {
			arg k;
			GtkTriggerButton("Rnd in grp", { this.pick_random_in_group(k) });
		});

		this.addAll(selectors, rndButtons, rndInGrpButtons);

		if (n > 1, {
			allRndButton = GtkTriggerButton("Rnd", { this.pick_random });
			allRndInGrpButton = GtkTriggerButton("Rnd in grp", { this.pick_random_in_group });
			this.add(allRndButton, allRndInGrpButton);
		});
	}

	pick_random {
		arg i;
		if (i.isNil, {
			selectors.doMsg(\pick_random)
		}, {
			selectors[i].pick_random;
		});
	}
	pick_random_in_group {
		arg i;
		if (i.isNil, {
			selectors.doMsg(\pick_random_in_group)
		}, {
			selectors[i].pick_random_in_group;
		});
	}

	at { |i| ^selectors[i] }
	state { ^selectors.collectMsg(\value) }
	state_ {	arg data; data.do({ |ids, i| selectors[i].value = ids }); }

	finalize {
		this.forgetEverything;
		super.finalize;
	}

	size { ^selectors.size }
}
