GtkMultiwidgetFrame : GtkFrame {
	var <visibleChild, box;
	var <>allowBadSwitch;

	*new {
		^super.new.initGtkMultiwidgetFrame
	}
	initGtkMultiwidgetFrame {
		visibleChild = nil;

		box = GtkVBox.new(false, 0);
		this.add(box);

		allowBadSwitch = true;

		box.show;
	}

	addChild {
		arg widget;
		if (box.children.includes(widget).not, {
			box.packStart(widget, true, true, 0);
		});
	}
	removeChild {
		arg widget;
		if (widget === visibleChild, {
			visibleChild = nil;
			this.setLabel;
		});
		box.remove(widget);
	}

	switchTo {
		arg widget, label;

		if (visibleChild.notNil, {
			visibleChild.hide;
		});

		if (widget.notNil and: { allowBadSwitch or: { box.children.includes(widget) } }, {
			visibleChild = widget;
			visibleChild.show;
			this.setLabel(label);
		}, {
			visibleChild = nil;
			this.setLabel;
		});
	}

	clear {
		box.removeAll;
		visibleChild = nil;
		this.setLabel;
	}
}
