GtkPresetButton : GtkToggleButton {
	var label, <values, <group;
	*new {
		arg group, values, actionF, openEditorF, n = 1;
		^super.new.initGtkPresetButton(group, values, actionF, openEditorF, n)
	}
	*newGroup {
		arg values, actionF, openEditorF, n = 1;	var buttons, group, button;
		buttons = Array.fill(3, {
			arg i;
			button = GtkPresetButton(group, values[i], actionF, openEditorF, n);
			button.setActive(i < n);
			group = button.group;
			button
		});
		^buttons
	}

	initGtkPresetButton {
		arg aGroup, someValues, actionF, openEditorF, n;

		group = aGroup ?? { GtkPresetButtonGroup(n) };
		group.add(this);
		
		label = GtkLabel.new;

		this.add(label);
		this.showChildren;
		this.connect('button-press-event', {
			arg button, event;
			var state, x, y;
			state = event.state;
			if ((state & Gdk.shift_mask) == 0, {
				false
			}, {
				#x, y = event.rootCoords;
				openEditorF.value(this, x, y);
				true
			})
		});
		this.connect('clicked', {
			var actives;
			if (this.getActive, {
				group.activate(this);
				actives = group.actives;
				group.do({
					arg button;
					if (actives.includes(button).not, {
						button.setActive(false);
					});
				});
				actionF.value(values)
			}, {
				if (group.actives.includes(this), {
					this.setActive(true)
				});
			});
		});

		this.values = someValues;
	}

	values_ {
		arg someValues;
		var text, maxlen;

		values = someValues.copy;
		maxlen = values.keys.asArray.collect({ |k| k.asString.size }).maxItem;

		values.keysValuesDo({
			arg key, value, i;		var keyS;
			keyS = key.asString;
			keyS = keyS ++ (" ".dup(maxlen - keyS.size)).join;
			text = text ++ keyS ++ ": " ++ value.asString;
			if (i != (values.size - 1), {
				text = text ++ "\n";
			});
		});

		label.setMarkup("<small><tt>" ++ text ++ "</tt></small>")
	}
}
