GtkServerControlPanel : GtkServerStatusDisplay {
	var hasMainGroup;
	var freeAllButton, runButton;

	*new {
		arg inServer, inActive = true;
		^super.new(inServer, inActive).initGtkServerControlPanel
	}

	initGtkServerControlPanel {
		var box;

		box = GtkHBox.new(false, 0);
		this.packEnd(box, false, false, 0);

		freeAllButton = GtkButton.newWithLabel("Free All");
		freeAllButton.connect('clicked', {
			server.freeAll;
		});
		box.packStart(freeAllButton, true, true, 0);

		if (server.maingroup.notNil, {
			server.notify(true);
			runButton = GtkToggleButton.newWithTwoLabels("Sleep", "Run");
			runButton.setActive(server.maingroup.isRunning);
			runButton.connect('clicked', {
				server.maingroup.run(runButton.getActive);
			});
			box.packStart(runButton, true, true, 0);
		});

		this.showAllChildren;
	}

	timeoutHandler {
		var maingroup, isRunning;

		maingroup = server.maingroup;

		if (maingroup.notNil, {
			isRunning = maingroup.isRunning;
			if (runButton.getActive != isRunning, {
				runButton.setActive(isRunning);
			});
		});

		super.timeoutHandler
	}
}
