GtkTimeBox : GtkHBox {
	var timeLabel, timeoutLabel;
	var updateTimeout;

	*new {
		^super.new(false, 0).initGtkTimeBox
	}
	initGtkTimeBox {
		var box, width = 60;

		timeoutLabel = GtkDisplayLabel.new("00:00:00");
		timeoutLabel.setSizeRequest(width, -1);
		this.packEnd(timeoutLabel, false, false, 0);

		timeLabel = GtkDisplayLabel.new("00:00:00");
		timeLabel.setSizeRequest(width, -1);
		this.packEnd(timeLabel, false, false, 0);

		updateTimeout = Gtk.timeoutAdd(1000, {
			this.updateDisplay;
			true;
		});

		this.showAllChildren(true);
	}

	updateDisplay {
		var date;

		date = Date.localtime;
		timeLabel.setText(date.format("%H:%M:%S"));
	}

	finalize {
		Gtk.timeoutRemove(updateTimeout);
		^super.finalize
	}
}
