MethodCallQueue {
	var <queue, object, argCollectors;

	*new {
		arg inObject, argCollector;
		^super.new.initMethodCallQueue(inObject, argCollector)
	}
	initMethodCallQueue {
		arg inObject, argCollector;
		argCollectors = List[];
		this.addArgCollector(argCollector);
		object = inObject;
		queue = SortedList.new;
		queue.function = { arg a, b; a.value < b.value }
	}

	add {
		arg method, priority;
		queue.add(method -> priority);
	}
	addUnique {
		arg method, function, priority;
		object.addUniqueMethod(method, function);
		queue.add(method -> priority);
	}

	perform {
		arg ...args;

		args = args ++ this.prCollectArgs;

		if (args.size == 0, {
			queue.do({
				arg item;
				if (item.isKindOf(Function), {
					item.value(object);
				}, {
					object.perform(item.key)
				});
			});
		}, {
			this.prPerformList(args);
		});
	}

	performList {
		arg args;
		args = args ++ this.prCollectArgs;
		this.prPerformList(args);
	}

	prPerformList {
		arg args;
		queue.do({
			arg item;
			if (item.isKindOf(Function), {
				item.valueArray([object] ++ args);
			}, {
				object.performList(item.key, args);
			});
		});
	}

	addArgCollector {
		arg argCollector;
		if (argCollector.notNil, { argCollectors.add(argCollector) });	
	}

	prCollectArgs {
		var args;
		args = argCollectors.collect({ |f| f.value });
		^args.flat
	}
}
