+ Collection {
	asGtkMenuItemArray {
		^this.asArray
	}

	asGtkMenu {
		arg commonAction, direction = \direct, sort = false;
		var menu, menuitem, collection;

		menu = GtkMenu.new;

		if (sort, {
			collection = this.asGtkMenuItemArray.copy.sort
		}, {
			collection = this.asGtkMenuItemArray;
		});

		collection.do({
			arg item;
			var name, value;

			menuitem = item.asGtkMenuItem;
			if (direction === \direct, {
				menu.append(menuitem);
			}, {
				menu.prepend(menuitem);
			});
			if (commonAction.notNil, {
				menuitem.connect("activate", {
					arg widget, value;
					commonAction.value(value);
				}, value);
			});
			menuitem.show;
		});
		^menu
	}

	asGtkAlphaPartitionedMenu {
		arg action;
		var menu, menuitem, collection;

		menu = GtkMenu.new;

		collection = this.asGtkMenuItemArray.copy.sort;

		collection.do({
			arg item;
			var name, value;

			if (item.isKindOf(Association), {
				name = item.key.asString;
				value = item.value;
			}, {
				name = item.asString;
				value = name;
			});

			menuitem = GtkMenuItem.newWithLabel(name);
			menu.append(menuitem);
			menuitem.connect("activate", {
				arg widget, value;
				action.value(value);
			}, value);
			menuitem.show;
		});
		^menu
	}
}

+ Dictionary {
	asGtkMenuItemArray {
		^this.keys.asArray
	}
}
