Presets {
	var presets;
	*initClass {
		ObjectSignals.register(this, #['changed'])
	}
	*new {
		^super.new.initPresets
	}
	initPresets {
		presets = List[]
	}
	size { ^presets.size }
	at { |i| ^presets[i] }
	add {
		arg data, name;
		name = name ? this.prMakeNewName;
		presets.add([name, data]);
		this.emit('changed');
		^name
	}
	update {
		arg n, name, data;
		if (name.notNil, { presets[n][0] = name });
		if (data.notNil, { presets[n][1] = data });
		this.emit('changed');
	}
	rename {
		arg n, name;
		presets[n][0] = name;
		this.emit('changed');
	}

	prMakeNewName {
		arg basename = "New preset";
		var i = 1, name;
		while({
			name = basename + i.asString;
			this.prNameIsUsed(name)
		}, {
			i = i + 1;
		});
		^name
	}
	prNameIsUsed { arg name; ^presets.detect({ arg preset; preset[0] == name}).notNil }

	read { arg filename; presets = Object.readArchive(filename); this.emit('changed') }
	write { arg filename; presets.writeArchive(filename) }
}