+ GtkWidget {
	//asCollapsable { arg name; ^GtkCollapsableFrame(name, this) }

	asCollapsingPair {
		arg name;

		var childFrame, childBox, childButtonBox, expandButton;
		var collapsedBox, collapsedChild, collapsedLabel, collapseButton;

		childFrame = GtkFrame(name);
		childFrame.show;

		childBox = GtkVBox.new;
		childFrame.add(childBox);
		childBox.show;

		childButtonBox = GtkHBox.new;
		childBox.packStart(childButtonBox, false, false);
		childButtonBox.show;

		collapseButton = GtkButton.newWithStockImage('gtk-remove', 'small-toolbar', callback: {
			collapsedBox.show;
			childFrame.hide;		
		});
		childButtonBox.packEnd(collapseButton, false, false);
		collapseButton.show;

		collapsedBox = GtkVBox.new;

		collapsedChild = GtkHBox.new;
		collapsedBox.packStart(collapsedChild, false, false);
		collapsedChild.show;

		collapsedLabel = GtkLabel.new(name ++ " (collapsed)", 0.5, 0.0);
		collapsedLabel.show;
		collapsedChild.packStart(collapsedLabel, true, true);

		expandButton = GtkButton.newWithStockImage('gtk-add', 'small-toolbar', callback: {
			collapsedBox.hide;
			childFrame.show;
		});
		collapsedChild.packEnd(expandButton, false, false);
		expandButton.show;

		childBox.packEnd(this, true, true);
		this.show;

		^[childFrame, collapsedBox]
	}

}

+ GtkBox {
	packCollapsable {
		arg name, widget, where='start', expand = false, fill = false;
		var expanded, collapsed;
		#expanded, collapsed = widget.asCollapsingPair(name);
	
		if (where == 'start', {
			this.packStart(expanded, expand, fill);
			this.packStart(collapsed, false, false);
		}, {
			this.packEnd(expanded, expand, fill);
			this.packEnd(collapsed, false, false);
		});
	}
}