+ Folder {
	asGtkItemTypeMenu {
		arg function, direction = \direct, sort = true;
		^this.itemTypes.keys.asGtkMenu(function, direction, sort);
	}
	asGtkItemAndSubfolderTypesMenu {
		arg itemTypeFunction, subfolderTypeFunction;
		var path, menu;

		menu = GtkMenu.new;

		this.itemTypes.keysValuesDo({
			arg name, class;

			menu.newItemAndConnect(name, {
				itemTypeFunction.value(class);
			});
		});

		menu.append(GtkSeparatorMenuItem.new.show);

		menu.newItemAndConnect(this.subfolderLogicName, {
			subfolderTypeFunction.value;
		});
		^menu
	}
	asGtkMenu {
		arg function;
		^this.populateGtkMenu(nil, function);
	}
	populateGtkMenu {
		arg inMenu, function, exclusionPred, tailItems;
		var menu, count;

		exclusionPred = exclusionPred ? {false};

		menu = this.treeCollect({
			arg path, object;

			if ((path.size == 0) || exclusionPred.value(path, object).not, {
				[true, nil]
			}, {
				[false, nil]
			});
		}, {
			arg path, object;
			var name, menuitem;
			if (exclusionPred.value(path, object).not, {
				name = path.last;
				menuitem = GtkMenuItem.newWithLabel(name);
				menuitem.connect("activate", {
					arg widget, path;
					function.value(path);
				}, path.copy);
				menuitem.show;
				menuitem
			}, {
				nil;
			});
		}, {
			arg path, object, collection;
			var menu, name, menuitem, childitem;

			if (collection.size == 0, {
				nil
			}, {
				menu = inMenu ? GtkMenu.new;

				collection.do({
					arg childitem;
					menu.append(childitem);
				});

				if ((collection.size > 1) && tailItems.notNil, {
					if (tailItems.size > 0, {
						childitem = GtkSeparatorMenuItem.new;
						menu.append(childitem);
						childitem.show;						
					});
					tailItems.do({
						arg item;

						childitem = GtkMenuItem.newWithLabel(item.key);
						menu.append(childitem);
						childitem.connect("activate", {
							arg widget, function, path;
							function.value(path);
						}, item.value, path.copy);
						childitem.show;	
					});					
				});

				if (path.size > 0, {
					name = path.last;
					menuitem = GtkMenuItem.newWithLabel(name);
					menuitem.show;
					menuitem.setSubmenu(menu);
					menuitem
				}, {
					menu
				});
			});
		});

		^menu
	}
}
