Path {
	var <array;

	*initClass {
		XmlNode.registerClass(this);
	}

	*new {
		^super.new.init
	}
	init {
		array = Array.new;
	}

	*newFromArray {
		arg inArray;
		^super.new.initFromArray(inArray)
	}
	initFromArray {
		arg inArray;
		array = inArray.copy;
	}

	asArray {
		^array
	}
	asString {
		^array.joinAsString
	}
	== {
		arg that;
		^(this.array == that.array)
	}

	// XML support
	fillXmlNode {
		arg node;
		var child;

		node.setProperty("size", array.size.asString);

		array.do({
			arg value, index;
			child = node.addChild("SEGMENT");
			child.setProperty("index", index.asString);
			child.setProperty("value", value.asString);
		});
	}
	parseXmlNode {
		arg node;
		var child, name, index, size;

		size = node.getProperty("size");
		if (size.notNil, {
			size = size.asInteger;
		}, {
			"malformed <PATH> XML node".warn;
			^this
		});

		array = Array.new.extend(size, nil);

		child = node.children;
		while({child.notNil}, {
			if (child.name == "SEGMENT" , {
				name = child.getProperty("value");
				index = child.getProperty("index");
				if (name.notNil && index.notNil, {
					array.put(index.asInteger, name.asSymbol);
				});
			});
			child = child.next;
		});
	}
}
