PathFilter : List {
	*initClass {
		ObjectSignals.register(this, #['changed'])
	}

	*new {
		arg ...array;
		^super.new.initPathFilter(array)
	}
	initPathFilter {
		arg array;
		var inclusive;

		forBy(0, array.size - 1, 2, {
			arg i;
			inclusive = array.at(i+1);
			if (inclusive.isKindOf(Boolean).not, {
				inclusive = (inclusive === '+');
			});
			this.add(PathPredicate.new(array.at(i).asPathPattern, inclusive));
		});
	}

	isActive {
		this.do({
			arg predicate;
			if (predicate.pattern.isAlwaysPositive && predicate.inclusive, {
				^false
			});
			if (predicate.pattern.isAlwaysNegative && predicate.inclusive, {
				^true
			});

		});
		^true
	}

	createGtkView {
		^GtkPathFilterView.new(this)
	}

	clear {
		super.clear;
		this.emit('changed');
	}
	add {
		arg predicate;
		super.add(predicate);
		this.emit('changed');
	}
	match {
		arg path;
		this.do({
			arg predicate;
			if (predicate.pattern.match(path), {
				^predicate.inclusive
			});
		});
		^false
	}
	value {
		arg path;
		^this.match(path)
	}
}
