PathPattern {
	var string, <array;
	var <isRelative;
	
 	*new {
		arg inString;
		^super.new.initPathPattern(inString);
	}
 	*newFromArray {
		arg inArray, inIsRelative = true;
		^super.new.initPathPatternFromArray(inArray, inIsRelative);
	}

	*newAlwaysPositive {
		^this.new("*")
	}
	*newAlwaysNegative {
		^this.new("")
	}

	initPathPattern {
		arg inString;
		this.set(inString ? "")
	}

	initPathPatternFromArray {
		arg inArray, inIsRelative = true;
		var inString;

		if (inIsRelative, {
			inString = inArray.joinAsString("/", "");
		}, {
			inString = inArray.joinAsString;
		});
		this.setFromArrayAndString(inArray, inString, inIsRelative);
	}

	set {
		arg inString;
		var inArray, inIsRelative;

		inArray = inString.split;

		if (inArray.first == "", {
			inIsRelative = false;
			inArray.removeAt(0);
		}, {
			inIsRelative = true;
		});

		this.setFromArrayAndString(inArray, inString, inIsRelative);
	}

	setFromArrayAndString {
		arg inArray, inString, inIsRelative = true;

		string = inString;
		array = inArray.collect({ arg item; WildExpr.new(item) });
		isRelative = inIsRelative;
	}

	match {
		arg path;
		var offset;

		if (array.size == 0, { ^false });

		path = path.asArray;

		if (isRelative, {
			if (array.size > path.size, {
				^false
			});
			offset = path.size - array.size;
			array.do({
				arg item, i;
 				if (item.match(path.at(offset + i)).not, {
					^false
				});
			});
		}, {
			if (array.size != path.size, {
				^false
			});
			array.do({
				arg item, i;
 				if (item.match(path.at(i)).not, {
					^false
				});
			});
		});

		^true
	}
	value {
		arg path;
		^this.match(path)
	}

	asString {
		^string
	}

	isAlwaysNegative {
		^(string == "")
	}
	isAlwaysPositive {
		^(string == "*")
	}

	*isGood {
		arg string;
		^string.isString
	}

	asPathPattern {
		^this
	}
}
