+ Dictionary {
	makeUniqueStringKey {
		arg basename;
		var n, name;

		n = 1;
		name = basename + "n." ++ n.asString; 
		while({ this.at(name).notNil }, {
			n = n + 1;
			name = basename + "n." ++ n.asString;
		});
		^name
	}

	*newWith {
		arg ...pairs;
		var dictionary;
		dictionary = Dictionary.new;
		pairs.do({ arg pair; dictionary.add(pair) });
		^dictionary
	}
}

+ Array {
	joinAsString {
		arg separator = "/", heading = "/";
		var result;

		this.do({
			arg item;
			if (result.isNil, {
				result = heading ++ item.asString
			}, {
				result = result ++ separator ++ item.asString;
			});
		});

		^(result ? heading.copy)
	}
	
	copyButLast {
		^this.copyFromStart(this.size - 2);
	}
	split {
		arg index;
		^[this.copyFromStart(index), this.copyToEnd(index + 1)]
	}
	splitBeforeLast {
		var a1, a2;
		#a1, a2 = this.split(this.size - 2)
		^[a1, a2.first]
	}
}

+ Collection {
	! {
		arg function;
		^this.collect(function);
	}

	/*
		(
			[1, 2, 3,4, 5, 6, 7, 8, 7, 6, 5, 4, 3, 2, 1].collectNotNil({
				arg item; var squared; squared = item ** 2; if (squared > 20, { nil }, { squared })
			});
		)

	*/

        collectNotNil { arg function;
                ^this.collectNotNilAs(function, this.species);
        }
        collectNotNilAs {
		arg function, class;
                var i, res, result;
                res = class.new;
                this.do({
			arg elem, i;
			result = function.value(elem, i);
			if (result.notNil, {
				res = res.add(result);
			});
		})
                ^res;
        }
}

+ SequenceableCollection {
	compareRange {
		arg that, begin, end, begin2;
		var offset;
		
		offset = (begin2 ? begin) - begin;

		begin.for(end, {
			arg i;
			if (this.at(i) != that.at(offset + i), {
				^false
			});
		});

		^true;
	}

	detectDifference {
		arg that;
		var upperindex, index;

		upperindex = min(this.size, that.size);
		if (upperindex == 0, { ^nil });

		upperindex.do({
			arg index;
			if (this.at(index) != that.at(index), {
				^index
			});
		});

		if (this.size != that.size, {
			^(upperindex)
		}, {
			^nil
		});
	}

	detectFrom {
		arg start, function;
		for (start, this.size - 1, {
			arg index;
			if (function.value(this.at(index), index), {
				^this.at(index)
			});
		});
		^nil
	}
	detectIndexFrom {
		arg start, function;
		for (start, this.size - 1, {
			arg index;
			if (function.value(this.at(index), index), {
				^index
			});
		});
		^nil
	}
}

+ String {
      findSubstring { arg string, begin = 0;
                var completed=0, size, matchBegin, i, char;
                size = string.size;
		matchBegin = begin;
		i = begin;
		while ({ i < this.size}, {
			char = this.at(i);

                        if(char == string.at(completed),{
                                completed = completed + 1;
                                if(completed == size,{
                                        ^matchBegin
                                })
                        },{
                                completed = 0;
				i = matchBegin;
				matchBegin = matchBegin + 1;
                        });

			i = i + 1;
                });
                ^nil
        }

	beginsWith {
		arg string;
		if (this.size < string.size, { ^false });
		string.do({
			arg c, i;
			if (this.at(i) !== c, { ^false });
		});
		^true
	}
}
