+ Char {
	*digitString {
		^"0123456789ABCEFGHIJKLMNOPQRSTUVWXYZ"
	}
}

+ Integer {
	asStringPrec { ^this.asString }
	asStringBase {
		arg n = 10;
		var m, string, p;

		if ((n < 2) || (n > 35), {
			error("must be 2 <= base <= 35. got " ++ n.asString);
			this.dumpBackTrace;
	                this.halt;
		});

		string = "";
		m = this.copy;
		while ({ m > 0 }, {
			p = m % n;
			string = Char.digitString.at(p).asString ++ string;
			m = (m / n).asInteger;
		});

		if (string == "", {
			string = "0";
		});

		^string
	}
	asHexString {
		^("0x" ++ this.asStringBase(16))
	}
	asOctalString {
		^("0" ++ this.asStringBase(2))
	}

	asStringPad {
		arg n, char = $0;
		var string;

		string = this.asString;
		if (n.notNil and: {string.size < n}, {
				string = String.new.addAll({char}.dup(n - string.size)) ++ string;
		});
		^string
	}
}
