TypedList {
	var dictionary;

	*new {
		^super.new.init
	}
	init {
		dictionary = IdentityDictionary[];
	}
	add {
		arg item;			var list;
		list = dictionary.atFail(item.class, { var list; list = List[]; dictionary.put(item.class, list); list });
		list.add(item);	
	}
	do {
		arg function;
		dictionary.do({ arg list; list.do(function); });
	}
	typedDo {
		arg type, function;				var list;
		list = dictionary[type];
		list.do(function);
	}
	typesDo {
		arg function;
		dictionary.keysValuesDo({ arg type, list, index; function.value(type, list, index); });
	}
	clear {
		dictionary = IdentityDictionary[];
	}
}

TypedUniqueList : TypedList {
	add {
		arg item;			var list;
		list = dictionary.atFail(item.class, { var list; list = List[]; dictionary.put(item.class, list); list });
		if (list.includes(item).not, {
			list.add(item);
		});
	}
}

TypedIdentityDictionary {
	var <dictionary;

	*new {
		^super.new.init
	}
	init {
		dictionary = IdentityDictionary[];
	}
	at {
		arg key;			var subdictionary;
		subdictionary = dictionary.at(key.class);
		if (subdictionary.isNil, { ^nil }, { subdictionary });
	}
	atFail {
		arg key, failFunction;	var item;
		item = this.at(key);
		if (item.isNil, { ^failFunction.value }, { item }); 
	}
	put {
		arg key, item;			var subdictionary;
		subdictionary = dictionary.atFail(key.class, {
			var subdictionary;
			subdictionary = IdentityDictionary[];
			dictionary.put(key.class, subdictionary);
			subdictionary
		});
		subdictionary.put(key, item);	
	}
	do {
		arg function;
		dictionary.do({ arg subdictionary; subdictionary.do(function); });
	}
	typedDo {
		arg type, function;				var subdictionary;
		subdictionary = dictionary[type];
		subdictionary.do(function);
	}
	keysDo {
		arg function;
		dictionary.do({ arg subdictionary; subdictionary.keysDo(function); });
	}
	typedKeysDo {
		arg type, function;				var subdictionary;
		subdictionary = dictionary[type];
		if (subdictionary.notNil, { subdictionary.keysDo(function) });
	}
	keysValuesDo {
		arg function;
		dictionary.do({ arg subdictionary; subdictionary.keysValuesDo(function); });
	}
	typedKeysValuesDo {
		arg type, function;				var subdictionary;
		subdictionary = dictionary[type];
		if (subdictionary.notNil, { subdictionary.keysValuesDo(function) });
	}
	clear {
		dictionary = IdentityDictionary[];
	}
	typesDo {
		arg function;
		dictionary.keysValuesDo({ arg type, list, index; function.value(type, list, index); });
	}
}
