WildExpr {
	var <pattern, <segments;

	*new {
		arg inPattern;
		^super.new.initWildExpr(inPattern)
	}
	initWildExpr {
		arg inPattern;
		this.pattern = inPattern;
	}

	match {
		arg string;
		var sindex, index, segment, index2, segment2;

		// BEGIN SPECIAL CASES
		if (segments == '*', {
			^true
		});
		if (segments == '' and: {string.size != 0 }, {
			^true
		});
		// END SPECIAL CASES

		string = string.asString;

		index = 0;
		sindex = 0;
		while ( { sindex < segments.size }, {
			segment = segments.at(sindex);
			if (segment.isString, {
				if (segment.compareRange(string, index, index + segment.size - 1).not, { 
					^false
				});
				index = index + segment.size;
			}, {
			if (segment === $?, {
				index = index + 1;
			}, {
				// The star
				if (sindex < (segments.size - 1), {
					segment2 = segments.at(sindex + 1);
					index2 = string.findSubstring(segment2, index);
					if (index2.isNil, {
						^false
					}, {
						index = index2 + segment2.size;
					});
					sindex = sindex + 1;
				}, {
					^true
				});
			});});
			sindex = sindex + 1;
		});
		^(index == string.size)
	}

	pattern_ {
		arg inPattern;
		var segment;

		pattern = inPattern.copy;

		case([
			{ pattern == "*" } -> {
				segments = '*';
			},
			{ pattern == "" } -> {
				segments = '';
			}
		], {
			segments = [];
			segment = "";
			pattern.do({
				arg c;
				if ((c === $?) or: { c === $* }, {
					if (segment.size > 0, {
						segments = segments.add(segment);
						segment = "";
					});
					if (segments.last != $*, {
						segments = segments.add(c);
					});
				}, {
					segment = segment ++ c;
				});
			});
			if (segment.size > 0, {
				segments = segments.add(segment);
			});
		});
	}
}
