FolderAggregateItem {
	var <object;

	*new {
		arg object;
		^super.newCopyArgs(object)
	}

	membersNames { ^this.subclassResponsibility(thisMethod) }
	members { ^this.subclassResponsibility(thisMethod) }
	memberGet { ^this.subclassResponsibility(thisMethod) }

	// To behave like a subfolder
	keyByIndex { arg index; ^this.membersNames[index] }
	at { arg key; ^this.memberGet(key) }
	atIndex { arg key; ^this.memberGet(key) }
}

DatasetAggregate : FolderAggregateItem {
	memberValueGet { ^this.subclassResponsibility(thisMethod) }
	memberValueSet { ^this.subclassResponsibility(thisMethod) }
}

PatchAsAggregate : DatasetAggregate {
	var nameToIndex;

	*new {
		arg patch;
		^super.new(patch).initPatchAsAggregate
	}
	initPatchAsAggregate {
		nameToIndex = IdentityDictionary[];
		object.argNamesForSynth.do({
			arg name, i;
			if (object.argsForSynth[i].isKindOf(Editor), {
				nameToIndex[name] = i;
			});
		});
	}
	nameToIndex {
		arg name;
		^object.argNamesForSynth.indexOf(name)
	}
	membersNames {
		^object.argNamesForSynth.select({ arg name; nameToIndex.includesKey(name) })
	}
	members {
		^object.argNamesForSynth.collectNotNilAs({
			arg name, index;
			if (nameToIndex.includesKey(name), {
				object.argsForSynth[index]
			}, {
				nil
			});
		}, Array)
	}
	memberGet {
		arg name;
		var index;
		if (name.isNumber, {
			index = name;
			if (index >= object.argsForSynth.size, { ^this });
		}, {
			index = nameToIndex[name];
			if (index.notNil, { ^this });
		});
		^object.argsForSynth[index]
	}

	memberValueSet {
		arg name, value;
		var arg0;

		arg0 = this.memberGet(name);
		if (arg0.notNil, {
			arg0.activeValue_(value).changed;
		});
	}
	memberValueGet {
		arg name, value;
		var arg0;

		arg0 = this.memberGet(name);

		if (arg0.notNil, {
			^arg0.value
		}, {
			^nil
		});
	}
}
