+ Object {
	hasXmlRepresentation {
		^XmlNode.classNodeNames.findKeyForValue(this.class).notNil
	}
	*newFromXmlNode {
		arg node, context;
		var object;
		if (this.needsContext, {
			object = this.new(context);
		}, {
			object = this.new;
		});
		object.parseXmlNode(node, context);
		^object
	}
	createXmlNode {
		arg parent, name...properties;
		var node;

		if (this.hasXmlRepresentation, {
			node = parent.addChild(this.class.xmlNodeName);
			this.fillXmlNode(node);

			if (name.notNil, {
				node.setProperty(this.class.namePropertyName, name);
			});
			properties.do({
				arg pair;
				if (pair.key.notNil && pair.value.notNil, {
					node.setProperty(pair.key.asString, pair.value.asString);
				});
			});

			^node
		}, {
			^nil
		});
	}
	createXmlRootNode {
		arg doc, name;
		var node;

		if (this.hasXmlRepresentation, {
			node = doc.createRoot(this.class.xmlNodeName);
			this.fillXmlNode(node);

			if (name.notNil, {
				node.setProperty(this.class.namePropertyName, name);
			});

			^node
		}, {
			^nil
		});
	}
	fillXmlNode {
		arg node;
	}
	parseXmlNode {
		arg node, context;
		this.parseXmlProperties(node, context);
		this.walkXmlChildren(node, context);
	}
	parseXmlProperties {
		arg node, context;
	}
	walkXmlChildren {
		arg node, context;
		var child;

		child = node.children;
		while({child.notNil}, {
			this.handleXmlChild(child, context);
			child = child.next;
		});
	}
	handleXmlChild {
		arg child, context;
	}
	*xmlNodeName {
		^this.name.asString.copy.toUpper
	}
	*namePropertyName {
		^"name"
	}
}

+ ArrayedCollection {
	fillXmlNode {
		arg node;
		var child;

		node.setProperty("size", this.size);

		this.do({
			arg item, index;
			child = item.createXmlNode(node);
			child.setProperty("index", index);
		});
	}
	handleXmlChild {
		arg child;
		var index, object;

		index = child.getProperty("index");
		if (index.notNil, {
			index = index.asString;
			object = child.buildItem;
			if (object.notNil, {
				this.put(index, object);
			});
		});
	}
}

+ Dictionary {
	// XML support
	hasXmlRepresentation {
		^true
	}
	fillXmlNode {
		arg node;
		this.keysValuesDo({
			arg name, object, i;
			object.createXmlNode(node, name);
		});
	}
	parseXmlNode {
		arg node;
		var child, name, object, pair;

		child = node.children;
		while({child.notNil}, {
			pair = child.buildItem;
			if (pair.notNil, {
				if (pair.key.notNil, {
				this.put(pair.key.asSymbol, pair.value);
				}, {
					Post << "IGNORING NODE: NO ITEM NAME" << "\n";
				});
			}, {
				Post << "IGNORING NODE: UNKNOWN CLASS" << "\n";
			});
			child = child.next;
		});
	}
}
