+ ArrayedCollection {
	interp {
		arg x;
		var i, f, a, b;

		if (this.size == 0, { ^nil } );

		if (x <= 0.0, { ^this.first });
		if (x >= 1.0, { ^this.last });

		i = x * (this.size - 1);
		if (i == i.asInteger, {
			^this.at(i.asInteger)
		}, {
			f = i.frac;
			i = i.asInteger;
			a = this.at(i);
			b = this.at(i + 1);
			^(a + ((b - a) * f))
		}); 
	}

	resample {
		arg i, n;
		var m, k, mi, ki, w, wt = 0.0, avg = 0.0;

		if (i.isInteger.not, {
			error("Index must be Integer\n");
			this.verboseHalt;
		});
		if (n.isInteger.not, {
			error("New size must be Integer\n");
			this.verboseHalt;
		});

		if (n == this.size, { ^this.at(i) });
		if (i > (n - 1), { ^nil });
		if (this.size == 1, { ^this.at(0) });

		m = this.size.asFloat / n;
		k = m * i;
		mi = m.roundUp.asInteger;
		ki = k.floor.asInteger;

		mi.do({
			arg j;

			case([
				{ (j == 0) and: (ki < k) } -> { w = 1.0 - k.frac },
				{ (j == (mi - 1)) and: (mi > m) } -> { w = m.frac }
			], { w = 1.0 });

			avg = avg + (this.at(ki + j) * w);

			wt = wt + w;
		});

		^(avg / wt)
	}
}
