#include <algorithm>

#include "gtkasyncrequests.h"

unsigned int gtkasyncrequests_get_requested_slot_size(void) {
  unsigned int slot_size = 0;

#include "gtkrequestsizes.h"

  return slot_size;
}

extern bool secondary_ticking_loop(VMGlobals *g, GtkRequestQueue::PollResult expected = GtkRequestQueue::INCOMING_RESULT);

void sc_glade_xml_connect_function(const gchar *handler_name,
				   GObject *object,
				   const gchar *signal_name,
				   const gchar *signal_data,
				   GObject *connect_object,
				   gboolean after,
				   gpointer user_data) { 
  PyrObject *wrapper = (PyrObject *)user_data;

  VMGlobals *g = gMainVMGlobals;

  if (connect_object) {
    pthread_mutex_lock(&gLangMutex);
    post("Swapped connection not supported for GladeXML. A connection has been lost.\n");
    pthread_mutex_unlock(&gLangMutex);
  } else {
    int size;

    pthread_mutex_lock(&gLangMutex);

    size = strlen(signal_name);
    PyrString *signalNameStringObj = newPyrStringN(g->gc, size, 0, true);
    memcpy(signalNameStringObj->s, signal_name, size);

    size = strlen(handler_name);
    PyrString *handlerNameStringObj = newPyrStringN(g->gc, size, 0, true);
    memcpy(handlerNameStringObj->s, handler_name, size);

    ++g->sp; SetObject(g->sp, wrapper);
    ++g->sp; SetInt(g->sp, int(object));
    ++g->sp; SetObject(g->sp, signalNameStringObj);
    ++g->sp; SetObject(g->sp, handlerNameStringObj);
    if (after) {
      ++g->sp; SetTrue(g->sp);
    } else {
      ++g->sp; SetFalse(g->sp);
    }
    runInterpreter(g, getsym("prPerformAutoconnect"), 5);

    pthread_mutex_unlock(&gLangMutex);

    secondary_ticking_loop(g, GtkRequestQueue::INCOMING_VOID);
  }
}
